// info dispDlg.cpp : implementation file
//

#include "stdafx.h"
#include "info disp.h"
#include "info dispDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif






// CinfodispDlg dialog



CinfodispDlg::CinfodispDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CinfodispDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_hIconOnline = AfxGetApp()->LoadIcon(IDI_ICON_ONLINE);
	m_hIconOffline = AfxGetApp()->LoadIcon(IDI_ICON_OFFLINE);
	m_hIconAway = AfxGetApp()->LoadIcon(IDI_ICON_AWAY);
	m_hIconXAway = AfxGetApp()->LoadIcon(IDI_ICON_XA);

	m_hIconMsg = AfxGetApp()->LoadIcon(IDI_ICON_MSG);
	m_hIconFile = AfxGetApp()->LoadIcon(IDI_ICON_FILE);
}

void CinfodispDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_LIST1, m_list);
}

BEGIN_MESSAGE_MAP(CinfodispDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
  ON_WM_COPYDATA()
  ON_WM_CLOSE()
END_MESSAGE_MAP()


// CinfodispDlg message handlers

BOOL CinfodispDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

  RECT rc;
  m_list.SetExtendedStyle(LVS_EX_FULLROWSELECT);
  m_list.GetWindowRect(&rc);
  m_list.InsertColumn(0, "Wiadomoci", LVCFMT_LEFT, rc.right-rc.left-28);

  m_imList.Create(16, 16, ILC_COLORDDB | ILC_MASK , 6, 6);
  m_imList.Add(m_hIconOnline);
  m_imList.Add(m_hIconOffline);
  m_imList.Add(m_hIconAway);
  m_imList.Add(m_hIconXAway);
  m_imList.Add(m_hIconMsg);
  m_imList.Add(m_hIconFile);

  m_list.SetImageList(&m_imList, LVSIL_SMALL);

  CWnd * wnd = FindWindow("KonnektNotifyWindow",NULL);
  if (wnd != NULL)
  {
    wnd->SendMessage(WM_KINFO_REG, (WPARAM)GetSafeHwnd(), NULL);
  }

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CinfodispDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CinfodispDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

BOOL CinfodispDlg::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct)
{
  if (pCopyDataStruct->dwData == MT_KINFO_MESSAGE)
  {
    if (pCopyDataStruct->cbData)
    {
      char *args = (char*)pCopyDataStruct->lpData;
      string name = GetExtParam(args, "name");

      char *nick = new char[name.length()+2]; // znak konca stringa i spacja na poczatku
      strcpy(nick, " ");
      strcat(nick, name.c_str());
      m_list.InsertItem(m_list.GetItemCount(), nick, 4);
      delete [] nick;
    }
  }
  else if (pCopyDataStruct->dwData == MT_KINFO_STATUS)
  {
    if (pCopyDataStruct->cbData)
    {
      char *args = (char*)pCopyDataStruct->lpData;
      string name = GetExtParam(args, "name");
      string stat = GetExtParam(args, "status");

      int status = atoi(stat.c_str());
      int icon = 1;
      switch (status)
      {
        case ST_OFFLINE:
        case ST_FREEFORCHAT:
          icon = 1;
          break;
        case ST_BLOCKING:
        case ST_NA:
        case ST_DND:
          icon = 3;
          break;
        case ST_ONLINE:
          icon = 0;
          break;
        case ST_AWAY:
          icon = 2;
          break;
      }

      char *nick = new char[name.length()+2]; // znak konca stringa i spacja na poczatku
      strcpy(nick, " ");
      strcat(nick, name.c_str());

      m_list.InsertItem(m_list.GetItemCount(), nick, icon);
      delete [] nick;
    }
  }
  else if (pCopyDataStruct->dwData == MT_KINFO_FILE)
  {
    if (pCopyDataStruct->cbData)
    {
      char *args = (char*)pCopyDataStruct->lpData;
      string name = GetExtParam(args, "name");
      string file = GetExtParam(args, "file");

      char *disp = new char[name.length()+file.length()+(string("  od ")).length()+1];
      strcpy(disp, " ");
      strcat(disp, file.c_str());
      strcat(disp, " od ");
      strcat(disp, name.c_str());

      m_list.InsertItem(m_list.GetItemCount(), disp, 5);
      delete [] disp;
    }
  }

  return CDialog::OnCopyData(pWnd, pCopyDataStruct);
}


void CinfodispDlg::OnClose()
{
  CWnd * wnd = FindWindow("KonnektNotifyWindow",NULL);
  if (wnd != NULL)
  {
    wnd->SendMessage(WM_KINFO_UNREG, (WPARAM)GetSafeHwnd(), NULL);
  }

  CDialog::OnClose();
}
