/*
 * Konnekt SDK (Software Development Kit)
 * 
 * Nagwek: plug Functions Definitions
 * Modyfikowany: 2003-09-19
 * Zgodny z wersj: 0.6.16.x
 * Info: Ciaa wszystkich f-cji z nagwkw.
 * 
 * rodowisko: Borland C++ i MS Visual C++
 * 
 * http://www.stamina.eu.org/konnekt/sdk/
 * 
 * (C)2002-2003 Stamina
 * SDK suy do przygotowywania oprogramowania wsppracujcego
 * z programem Konnekt. Autorzy nie ponosz adnej odpowiedzialnoci
 * za wykorzystanie tego kodu.
 * Kod zawarty w SDK moe by uywany tylko w projektach dotyczcych
 * programu Konnekt! */


#include <stdio.h>
#include <stdarg.h>
#include <windows.h>
#include <commctrl.h>
#include <string>
#include "plug_shared.h"
#include "ui_shared.h"


extern cCtrl * Ctrl = 0;

// ___________________________________________________
// plug_export.h
// ---------------------------------------------------
  int IMessage(unsigned int  id , signed int net=0 , unsigned int type=-1 , int p1=0 , int p2=0) {
    return (Ctrl->IMessage)(&sIMessage (id,net,type,p1,p2));
  }
  int IMessage(sIMessage_base * msg) {
    return Ctrl->IMessage(msg);
  }
  int ICMessage(unsigned int  id , int p1=0 , int p2=0) {
    return (Ctrl->IMessage)(&sIMessage (id,0,0,p1,p2));
  }
  int IMessageDirect(unsigned int  id , unsigned int plug=0, int p1=0 , int p2=0) {
    if (!plug) plug=Ctrl->ID();
    return (Ctrl->IMessageDirect)(plug , &sIMessage (id,0,0,p1,p2));
  }

  int IMessageDirect(unsigned int plug , sIMessage_base * msg) {
    return Ctrl->IMessageDirect(plug , msg);
  }

  const char * SAFECHAR(const char * ch) {return ch?ch:"";}

  int Plug_Init(int p1 , int p2) {
    Ctrl=(cCtrl*)p1;
    return 1;
  }

  void Plug_Deinit(int p1 , int p2) {
    return;
  }

  void WMProcess(void) {
      Ctrl->WMProcess();
  }


#ifdef __BORLANDC__
#define VSNPRINTF vsnprintf
#else
#define VSNPRINTF _vsnprintf
#endif
#ifdef IMLOG_AUTOALLOC
char * __vsaprintf(const char *format, va_list ap)
{
            va_list temp_ap = ap;
            char *buf = NULL, *tmp;
            int size = 0, res;
            if ((size = VSNPRINTF(buf, 0, format, ap)) < 1) {
                    size = 128;
                    do {
                            size *= 2;
                            if ((tmp = (char*)realloc(buf, size))==0) {
                                    free(buf);
                                    return NULL;
                            }
                            buf = tmp;
                            res = VSNPRINTF(buf, size, format, ap);
                    } while (res == size - 1 || res==-1);
            } else {
                    if ((buf = (char*)malloc(size + 1))==0)
                            return NULL;
            }
            ap = temp_ap;
            VSNPRINTF(buf, size + 1, format, ap);
            return buf;
    }
#endif

#ifndef NO_PLUG_EXPORT


     bool SETSTR(int id , const char * val) {
         sDTValue v(DT_CT_STR);
         v.vCChar = val;
         return Ctrl->DTset(DTCFG , 0 , id, &v);
     }    
     bool SETINT(int id , int val , int mask) {
         sDTValue v(DT_CT_INT);
         if (mask != -1) { // maskowanie
             Ctrl->DTget(DTCFG , 0 , id, &v);
             v.vInt = (v.vInt & ~mask) | val;
             return Ctrl->DTset(DTCFG , 0 , id, &v);
         } else {
             v.vInt = val;
             return Ctrl->DTset(DTCFG , 0 , id, &v);
         }
     }    
     const char * GETSTR(int id , char * buff , unsigned int size) {
         sDTValue v(DT_CT_STR);
         v.vChar = buff;
         v.buffSize = size;
         Ctrl->DTget(DTCFG , 0 , id, &v);
         return v.vCChar;
     }    
     int GETINT(int id) {
         sDTValue v(DT_CT_INT);
         Ctrl->DTget(DTCFG , 0 , id, &v); 
         return v.vInt;
     }    

     bool SETCNTI(int row , int id , int val , int mask) {
         sDTValue v(DT_CT_INT);
         if (mask != -1) { // maskowanie
             Ctrl->DTget(DTCNT , row , id, &v);
             v.vInt = (v.vInt & ~mask) | val;
             return Ctrl->DTset(DTCNT , row , id, &v);
         } else {
            v.vInt = val;
            return Ctrl->DTset(DTCNT , row , id, &v); 
         }
     }
	 bool SETCNTI64(int row , int id , __int64 val, __int64 mask) {
         sDTValue v(DT_CT_64);
         if (mask != -1) { // maskowanie
             Ctrl->DTget(DTCNT , row , id, &v);
             v.vInt64 = (v.vInt64 & ~mask) | val;
             return Ctrl->DTset(DTCNT , row , id, &v);
         } else {
            v.vInt64 = val;
            return Ctrl->DTset(DTCNT , row , id, &v); 
         }
     }


     bool SETCNTC(int row , int id , const char * val) {
         sDTValue v(DT_CT_PCHAR);
         v.vCChar = val;
         return Ctrl->DTset(DTCNT , row , id, &v); 
     }
     int GETCNTI(int row , int id) {
         sDTValue v(DT_CT_INT); 
         Ctrl->DTget(DTCNT , row , id, &v); 
         return v.vInt;}

	 __int64 GETCNTI64(int row , int id) {
		 sDTValue v(DT_CT_64); 
         Ctrl->DTget(DTCNT , row , id, &v); 
         return v.vInt64;}

     const char * GETCNTC(int row , int id , char * buff , unsigned int size) {
         sDTValue v(DT_CT_PCHAR); 
         v.vChar = buff;
         v.buffSize = size;
         Ctrl->DTget(DTCNT , row , id, &v); 
         return v.vCChar;}


 void IMLOG(const char *format, ...) {
	va_list ap;
    char buffer [255];
	va_start(ap, format);
    int size = VSNPRINTF(buffer , sizeof(buffer) , format,ap);
    buffer[sizeof(buffer)-1]=0;
#ifdef IMLOG_AUTOALLOC
    if (size==-1 || size>sizeof(buffer)) {
        char * buff = __vsaprintf(format , ap);
        IMessage(IMC_LOG , 0,0,(LPARAM)buff,0);
        free(buff);
    } else 
#endif    
    {IMessage(IMC_LOG , 0,0,(int)buffer,0);}

	va_end(ap);
  }

#ifdef _WINDOWS_
void IMERROR() {  //Windows errors
        if (GetLastError()) {
           #ifdef WINFUNCH
             IMLOG("E[%d] %s" , GetLastError() , GetLastErrorMsg());
           #else
             IMLOG("E[%d] ..." , GetLastError());
           #endif
        }
  }
#endif


#endif //NO_PLUG_EXPORT

// ___________________________________________________
// plug_shared.h
// ---------------------------------------------------




int cCtrl::DTgetInt(char db , unsigned int row , unsigned int col) {
    sDTValue v(DT_CT_INT); 
    DTget(db , row , col, &v); 
    return v.vInt;
}
bool cCtrl::DTsetInt(char db , unsigned int row , unsigned int col , int val , int mask){
    sDTValue v(DT_CT_INT);
    if (mask != -1) { // maskowanie
        DTget(db , row , col, &v);
        v.vInt = (v.vInt & ~mask) | val;
        return DTset(db , row , col, &v);
    } else {
        v.vInt = val;
        return DTset(db , row , col, &v); 
    }
}
char * cCtrl::DTgetStr(char db , unsigned int row , unsigned int col , char * buff , unsigned int size){
    sDTValue v(DT_CT_PCHAR); 
    v.vChar = buff;
    v.buffSize = size;
    DTget(db , row , col, &v); 
    return v.vChar;
}
bool cCtrl::DTsetStr(char db , unsigned int row , unsigned int col , const char * val){
    sDTValue v(DT_CT_PCHAR);
    v.vCChar = val;
    return DTset(db , row , col, &v); 
}
__int64 cCtrl::DTgetInt64(char db , unsigned int row , unsigned int col) {
    sDTValue v(DT_CT_64); 
    DTget(db , row , col, &v); 
    return v.vInt64;
}
bool cCtrl::DTsetInt64(char db , unsigned int row , unsigned int col , __int64 val , __int64 mask) {
    sDTValue v(DT_CT_64);
    if (mask != -1) { // maskowanie
        DTget(db , row , col, &v);
        v.vInt64 = (v.vInt64 & ~mask) | val;
        return DTset(db , row , col, &v);
    } else {
        v.vInt64 = val;
        return DTset(db , row , col, &v); 
    }
}




 
// ___________________________________________________
// plug_func.h
// ---------------------------------------------------

    int UIActionAdd(int _parent , int _id , int _status=0 , const char * _txt = 0 , int _p1=0 , short _w=0 , short _h=0 , int _p2=0 , int _param=0) {
       sUIActionInfo ai = sUIActionInfo(_parent , _id , -1 , _status , (char*)_txt , _p1 , _w , _h , _p2 , _param);
       return ICMessage(IMI_ACTION , (IMPARAM)&ai);
    }

    int UIActionInsert(int _parent , int _id , int _pos , int _status=0 , const char * _txt = 0 , int _p1=0 , short _w=0 , short _h=0 , int _p2=0 , int _param=0) {
       sUIActionInfo ai = sUIActionInfo(_parent , _id , _pos , _status , (char*)_txt , _p1 , _w , _h , _p2 , _param);
       return ICMessage(IMI_ACTION , (IMPARAM)&ai);
    }

    int UIActionCfgAdd(int _parent , int _id , int _status=0 , const char * _txt = 0 , int _p1=0 , short _x=0 , short _y=0 , short _w=0 , short _h=0 , int _p2=0 , int _param=0) {
       sUIActionInfo_cfg ai = sUIActionInfo_cfg(_parent , _id , -1 , _status , (char*)_txt , _p1 , _x , _y , _w , _h , _p2 , _param);
       return ICMessage(IMI_ACTION , (IMPARAM)&ai);
    }

    int UIActionCfgInsert(int _parent , int _id , int _pos , int _status=0 , const char * _txt = 0 , int _p1=0 , short _x=0 , short _y=0 , short _w=0 , short _h=0 , int _p2=0 , int _param=0) {
       sUIActionInfo_cfg ai = sUIActionInfo_cfg(_parent , _id , _pos , _status , (char*)_txt , _p1 , _x , _y , _w , _h , _p2 , _param);
       return ICMessage(IMI_ACTION , (IMPARAM)&ai);
    }

    int UIGroupAdd(int _parent , int _id , int _status=0 , const char * _txt = 0 , int _p1=0 , short _w=0 , short _h=0 , int _p2=0 , int _param=0) {
        return UIActionAdd(_parent , _id , _status | ACTS_GROUP , (char*)_txt , _p1 , _w , _h , _p2 , _param);
    }

    int UIGroupInsert(int _parent , int _id , int _pos , int _status=0 , const char * _txt = 0 , int _p1=0 , short _w=0 , short _h=0 , int _p2=0 , int _param=0) {
        return UIActionInsert(_parent , _id , _pos , _status | ACTS_GROUP , (char*)_txt , _p1 , _w , _h , _p2 , _param);
    }

    int UIActionGetPos(int _parent , int _id) {
        sUIActionInfo ai;
        ai.act = sUIAction(_parent , _id);
        ai.mask = UIAIM_POS;
        ICMessage(IMI_ACTION_GET , (int)&ai);
        return ai.pos;
    }

    int UIActionSetStatus(sUIAction act , int status , int mask = -1) {
        sUIActionInfo ai;
        ai.act = act;
        ai.mask = UIAIM_STATUS;
        ai.status = status;
        ai.statusMask = mask;
        return ICMessage(IMI_ACTION_SET , (int)&ai);
    }
    int UIActionGetStatus(sUIAction act) {
        sUIActionInfo ai;
        ai.act = act;
        ai.mask = UIAIM_STATUS;
        ai.statusMask = -1;
        ICMessage(IMI_ACTION_GET , (int)&ai);
        return ai.status;
    }
	void * UIActionHandle(sUIAction act) {
        sUIActionInfo ai;
        ai.act = act;
		ai.mask = UIAIM_HANDLE;
        ICMessage(IMI_ACTION_GET , (int)&ai);
        return ai.handle;
	}
	int UIActionCall(sUIActionNotify_base * an) {
		return ICMessage(IMI_ACTION_CALL , (int)an);
	}
	void * UIActionHandleDirect(sUIAction act) {
		sUIActionNotify_2params an(act , ACTN_SETCNT , AC_CURRENT , 0);
		UIActionCall(&an);
        return (void*)an.notify2;
	}



    int UIActionSetStatus(int parent , int id , int status , int mask = -1) {
        return UIActionSetStatus(sUIAction(parent,id),status,mask);
    }
    int UIActionSetText(sUIAction act , const char * txt) {
        sUIActionInfo ai;
        ai.act = act;
        ai.mask = UIAIM_TXT;
        ai.txt = (char *)txt;
        return ICMessage(IMI_ACTION_SET , (int)&ai);
    }
    int UIActionSetText(int parent , int id , const char * txt) {
        return UIActionSetText(sUIAction(parent , id) , txt);
    }
    int UIActionCfgSetValue(sUIAction act , const char * val) {
        sUIActionInfo ai;
        ai.act = act;
        ai.mask = UIAIM_TXT;
        ai.txt = (char *)val;
        return ICMessage(IMI_ACTION_SETVALUE , (int)&ai);
    }
    const char * UIActionCfgGetValue(sUIAction act , char * val , int size) {
        sUIActionInfo ai;
        ai.act = act;
        ai.mask = UIAIM_TXT;
        ai.txt = (char *)val;
        ai.txtSize = size;
        ai.txt = (char*)ICMessage(IMI_ACTION_GETVALUE , (int)&ai);
        return ai.txt;
    }

    int UIActionSet(sUIActionInfo & nfo) {
        return ICMessage(IMI_ACTION_SET , (int)&nfo);
    }
    int UIActionGet(sUIActionInfo & nfo) {
        return ICMessage(IMI_ACTION_GET , (int)&nfo);
    }
    void * UIGroupHandle(sUIAction act) {
        return (HANDLE)ICMessage(IMI_GROUP_GETHANDLE , (int)&act);
    }


    int IconRegister(IML_enum target , int ID , const char * URL) {
        sUIIconRegister ir;
        ir.URL = URL;
        ir.ID = ID;
        ir.target = target;
        ICMessage(IMI_ICONREGISTER , (int)&ir);
        return ID;
    }
    int IconRegister(IML_enum target , int ID , HINSTANCE inst , int icoID , int type = 1) {
        sUIIconRegister ir;
        ir.ID = ID;
        ir.target = target;
        ir.imgInst = inst;
        ir.imgId = icoID;
        ir.imgType = type;
        ICMessage(IMI_ICONREGISTER , (int)&ir);
        return ID;
    }
    int IconRegister(IML_enum target , int ID , HANDLE image, int type = 1) {
        sUIIconRegister ir;
        ir.ID = ID;
        ir.target = target;
        ir.imgHandle = image;
        ir.imgType = type;
        ICMessage(IMI_ICONREGISTER , (int)&ir);
        return ID;
    }
    int IconRegisterList(IML_enum target , int count , int * IDList , HANDLE image , HANDLE mask=0 , int w = 0) {
        sUIIconRegisterList irl;
        irl.target = target;
        irl.count = count;
        irl.idList = IDList;
        irl.imgBmp = image;
        irl.maskBmp = mask;
        irl.w = w;
        return ICMessage(IMI_ICONREGISTERLIST , (int)&irl);
    }
#ifdef _INC_COMMCTRL
    int IconRegisterList(IML_enum target , int count , int * IDList , HIMAGELIST ImageList) {
        sUIIconRegisterList irl;
        irl.target = target;
        irl.count = count;
        irl.idList = IDList;
        irl.ImageList = ImageList;
        return ICMessage(IMI_ICONREGISTERLIST , (int)&irl);
    }
#endif

    bool GetExtParam(const char * ext , const char * name , char * valueBuff , size_t buffSize) {
        *valueBuff = 0;
        if (!*name) return false;
        // To, czego chcemy szuka
        size_t nameLen = strlen(name);
        char * find = new char [nameLen+3];
        strcpy(find+1 , name);
        find[0] = EXT_PARAM_CHAR;
        strcpy(find + nameLen+1 , "=\0");
        // Znajdujemy parametr
        char * start = strstr(ext , find);
        size_t size = 0;
        delete [] find;
        if (!start) return false;
        start += nameLen + 2;
        // Kopiujemy warto
        while (*start && *start!=EXT_PARAM_CHAR && size<buffSize-1) {
            *valueBuff=*start;
            valueBuff++;
            start++;
            size++;    
        }
        *valueBuff=0;
        return true;
    }

    bool SetExtParam(const char * ext , const char * name , const char * value , char * extBuff , size_t buffSize) {
        if (!*name) return false;
        size_t nameLen = strlen(name);
        size_t extLen = strlen(ext);
        size_t valueLen = strlen(value);
        char * find = new char [nameLen+3]; // To, czego chcemy szukac
        strcpy(find+1 , name);
        find[0] = EXT_PARAM_CHAR;
        strcpy(find + nameLen+1 , "=\0");
        char * start = strstr(ext , find);   // Znajdujemy parametr
        // Sprawdzamy, czy to co nam powstanie, w ogole zmiesci sie w pamieci.
        if (!start && buffSize < extLen + nameLen + valueLen + 3) {return false;}
        // Kopiujemy to, co i tak nie zostanie zmienione. Jezeli ext i extBuff to to samo - nie ma sensu kopiowac.
        // Nie kopiujemy calej czesci ze zmieniana wartoscia - ona powedruje na koniec...
        if (ext != extBuff) strncpy(extBuff , ext , min(start?(start - ext):(extLen) , buffSize));
        char * end = start?strchr(start + 1 , EXT_PARAM_CHAR):0;
        // Kopiujemy reszte parametrow
        if (end) strncpy(extBuff + (start - ext) , end , buffSize - (start - ext));
        // Teraz mozemy dopiero zapisac nasz nowy parametr
        extLen = strlen(extBuff);
        if (buffSize < extLen + nameLen + valueLen + 3) return false;
        strcpy(extBuff + extLen , find); // Zapisujemy nazwe
        strcpy(extBuff + extLen + nameLen + 2 , value);
        delete [] find;
        return true;
    }

#ifdef _STRING_
    std::string GetExtParam(const std::string ext , const std::string name) {
        if (name.empty()) return "";
        size_t start = ext.find(EXT_PARAM_CHAR + name + "="); // Znajdujemy parametr
        if (start == ext.npos) return "";
        start += name.length() + 2;
        size_t end = ext.find(EXT_PARAM_CHAR , start); // Znajdujemy koniec wartosci
        return ext.substr(start , (end==ext.npos)?end:end - start); // Zwracamy kopie
    }

    std::string SetExtParam(const std::string ext , const std::string name , const std::string value) {
        if (name.empty()) return ext;
        size_t start = ext.find(EXT_PARAM_CHAR + name + "="); // Znajdujemy parametr
        size_t end = (start==ext.npos)?ext.npos :ext.find(EXT_PARAM_CHAR , start + 1); // Znajdujemy koniec wartosci
        return ext.substr(0 , start) + EXT_PARAM_CHAR + name + "=" + value + ((end!=ext.npos)?ext.substr(end):"");
    }
#endif


int CntSetStatus(unsigned int cntID , unsigned int status , const char * info) {
    return Ctrl->IMessage(&sIMessage_StatusChange(IMC_CNT_SETSTATUS , cntID , status , info));
}
int PlugStatusChange(unsigned int status , const char * info = 0) {
    return Ctrl->IMessage(&sIMessage_StatusChange(IMC_STATUSCHANGE , 0 , status , info));
}



cMessage * messageDuplicate(cMessage * m) {
    cMessage * mc = new cMessage;
    *mc = *m;
    mc->body = strdup(m->body);
    mc->ext = strdup(m->ext);
    mc->fromUid = strdup(m->fromUid);
    mc->toUid = strdup(m->toUid);
    return mc;
}
void messageFree(cMessage * m) {
    free(m->body);
    free(m->ext);
    free(m->fromUid);
    free(m->toUid);
    delete m;
}
