/*
 * Konnekt SDK (Software Development Kit)
 * 
 * Nagwek: plug Functions
 * Modyfikowany: 2003-09-19
 * Zgodny z wersj: 0.6.16.x
 * Info: Zestaw makr i funkcji pomocniczych.
 * 
 * rodowisko: Borland C++ i MS Visual C++
 * 
 * http://www.stamina.eu.org/konnekt/sdk/
 * 
 * (C)2002-2003 Stamina
 * SDK suy do przygotowywania oprogramowania wsppracujcego
 * z programem Konnekt. Autorzy nie ponosz adnej odpowiedzialnoci
 * za wykorzystanie tego kodu.
 * Kod zawarty w SDK moe by uywany tylko w projektach dotyczcych
 * programu Konnekt! */

#ifndef PLUGFUNCH
#define PLUGFUNCH

/**\file
  Zestaw makr i funkcji pomocniczych . <br><br>
  Musi by include'owany po plug_export.h.  
*/


/**
\addtogroup imi_action_
\{
*/

    /**\defgroup action_makra Funkcje pomocnicze.
     \{
    */

    /** Do wstawienia w switch'u akcji. Jeli akcja nie zostaa wywoana z kodem ACTN_ACTION - wychodzi. */
    #define ACTIONONLY(notify) if (notify->code != ACTN_ACTION) return 0
    /** Pusta akcja. */
    #define NOACTION sUIAction(0,0)
    /** Sprawdza czy cCtrl::isRunning() zwraca true, jeli nie, wychodzi. */
    #define ISRUNNING() if (!Ctrl->isRunning()) {Ctrl->setError(IMERROR_SHUTDOWN); return 0;}

    /// Dodaje akcj.
    /// \blank
    int UIActionAdd(int _parent , int _id , int _status=0 , const char * _txt = 0 , int _p1=0 , short _w=0 , short _h=0 , int _p2=0 , int _param=0);
    /// Wstawia akcj.
    /// \blank
    int UIActionInsert(int _parent , int _id , int _pos , int _status=0 , const char * _txt = 0 , int _p1=0 , short _w=0 , short _h=0 , int _p2=0 , int _param=0);

    /// Dodaje akcj do konfiguracji.
    /// \blank
    int UIActionCfgAdd(int _parent , int _id , int _status=0 , const char * _txt = 0 , int _p1=0 , short _x=0 , short _y=0 , short _w=0 , short _h=0 , int _p2=0 , int _param=0);
    /// Wstawia akcj do konfiguracji.
    /// \blank
    int UIActionCfgInsert(int _parent , int _id , int _pos , int _status=0 , const char * _txt = 0 , int _p1=0 , short _x=0 , short _y=0 , short _w=0 , short _h=0 , int _p2=0 , int _param=0);


    /// Dodaje grup.
    /// \blank
    int UIGroupAdd(int _parent , int _id , int _status=0 , const char * _txt = 0 , int _p1=0 , short _w=0 , short _h=0 , int _p2=0 , int _param=0);
    /// Wstawia grup.
    /// \blank
    int UIGroupInsert(int _parent , int _id , int _pos , int _status=0 , const char * _txt = 0 , int _p1=0 , short _w=0 , short _h=0 , int _p2=0 , int _param=0);
    /// Zwraca pozycj w grupie.
    /// \blank
    int UIActionGetPos(int _parent , int _id);

    /// Pobiera akcje.
    /// \blank
    int UIActionSet(sUIActionInfo & nfo);
    /// Ustawia akcje.
    /// \blank
    int UIActionGet(sUIActionInfo & nfo);


    /// Ustawia status.
    /// \blank
    int UIActionSetStatus(sUIAction act , int status , int mask = -1);
    /// \blank
    int UIActionGetStatus(sUIAction act);

	/// Zwraca uchwyt grupy
	void * UIGroupHandle(sUIAction act);
	/// Zwraca uchwyt akcji
	void * UIActionHandle(sUIAction act);
	/** Zwraca uchwyt akcji dla kontrolek z ACTR_SETCNT
	    W niektrych przypadkach pozwala na pobranie uchwytu
		bez zmieniania kontaktu przypisanego do akcji...
	*/
	void * UIActionHandleDirect(sUIAction act);
	int UIActionCall(sUIActionNotify_base * an);

    int UIActionSetStatus(int parent , int id , int status , int mask = -1);
    /// Ustawia text.
    /// \blank
    int UIActionSetText(sUIAction act , const char * txt);
    int UIActionSetText(int parent , int id , const char * txt);
    /// Ustawia wartosc kontrolki w konfiguracji.
    /// \blank
    int UIActionCfgSetValue(sUIAction act , const char * val);
    /// Pobiera wartosc kontrolki z konfiguracji.
    /// \blank
    const char * UIActionCfgGetValue(sUIAction act , char * val , int size);
    ///\}

/// \}   // imi_action

 /** @defgroup icon_makra Funkcje do ikonek
     @{
    */

    /** \brief \no */
    int IconRegister(IML_enum target , int ID , const char * URL);
    /** \brief \no */
    int IconRegister(IML_enum target , int ID , HINSTANCE inst , int icoID , int type = 1);
    /** \brief \no */
    int IconRegister(IML_enum target , int ID , HANDLE image, int type = 1);
    /** \brief \no */
    int IconRegisterList(IML_enum target , int count , int * IDList , HANDLE image , HANDLE mask=0 , int w = 0);
#ifdef _INC_COMMCTRL
    /** \brief \no */
    int IconRegisterList(IML_enum target , int count , int * IDList , HIMAGELIST ImageList);
#endif

 /** @} */

    /** \blank \no */
    bool GetExtParam(const char * ext , const char * name , char * valueBuff , size_t buffSize);
    /** \blank \no */
    bool SetExtParam(const char * ext , const char * name , const char * value , char * extBuff , size_t buffSize);
#ifdef _STRING_
    /** \blank \no */
    std::string GetExtParam(const std::string ext , const std::string name);
    /** \blank \no */
    std::string SetExtParam(const std::string ext , const std::string name , const std::string value);
#endif


    /** Ustawia status kontaktu. */
    int CntSetStatus(unsigned int cntID , unsigned int status , const char * info = 0);
    /** Powinno by uruchomione zaraz przed zmian statusu wtyczki. */
    int PlugStatusChange(unsigned int status , const char * info = 0);


/** Tworzy wtek i czeka a si skoczy.
\param proc Adres procedury wtku.
\param param Parametr przekazywany do procedury.*/
#define CreateThreadAndWait(proc , param) \
         {\
          /*HANDLE th = OpenThread(THREAD_QUERY_INFORMATION , 0 , _beginthread((proc) , 0 , (void*)(param)));*/ \
          HANDLE th = (HANDLE) _beginthread((void(*)(void*))(proc) , 0 , (void*)(param));\
          unsigned long ec;\
          while (GetExitCodeThread(th , &ec) && ec==STILL_ACTIVE) {\
            if (!Ctrl->Is_TUS(0)) {\
              MsgWaitForMultipleObjectsEx(0 , 0 , INFINITE , QS_ALLINPUT | QS_ALLPOSTMESSAGE , MWMO_ALERTABLE | MWMO_INPUTAVAILABLE);\
              Ctrl->WMProcess();\
            }\
          }\
          /*CloseHandle(th);*/ \
         }
/** Wysya #IMC_CFG_SETCOL z podanymi parametrami (id , type , def).
*/
#define CfgSetCol(_id , _type , _def) {\
    sSETCOL sc; \
    sc.id = (_id);\
    sc.type= (_type); \
    sc.def = (int)(_def); \
    ICMessage(IMC_CFG_SETCOL , (int)&sc); \
  }

/** Tworzy kopie cMessage. 
    Wykorzystywane, gdy po odebraniu np. #IM_MSG_SEND wysyamy wiadomo
    w osobnym wtku. Tworzymy kopi w IMessageProcess, a zwalniamy
    na kocu wtku. F-cja alokuje ca struktur!
*/
cMessage * messageDuplicate(cMessage * m);
/** Zwalnia cMessage (to co zaalokowa messageDuplicate. */
void messageFree(cMessage * m);

/** Zamienia cztery parametry wersji w liczbe typu long. */
#define VERSION_TO_NUM(maj,min,rls,bld) ((((maj)&0xF)<<28) | (((min)&0xFF)<<20) | (((rls)&0xFF)<<12) | ((bld)&0xFFF))
#define VERSION_MAJ(ver) (((ver)&0xF)>>28)
#define VERSION_MIN(ver) (((ver)&0xFF)>>20)
#define VERSION_RLS(ver) (((ver)&0xFF)>>12)
#define VERSION_BLD(ver) ((ver)&0xFFF)

#endif