/*
 * Konnekt SDK (Software Development Kit)
 * 
 * Nagwek: Plug Shared
 * Modyfikowany: 2003-09-21
 * Zgodny z wersj: 0.6.16.x
 * Info: Podstawowy nagwek.
 * 
 * rodowisko: Borland C++ i MS Visual C++
 * 
 * http://www.stamina.eu.org/konnekt/sdk/
 * 
 * (C)2002-2003 Stamina
 * SDK suy do przygotowywania oprogramowania wsppracujcego
 * z programem Konnekt. Autorzy nie ponosz adnej odpowiedzialnoci
 * za wykorzystanie tego kodu.
 * Kod zawarty w SDK moe by uywany tylko w projektach dotyczcych
 * programu Konnekt! */


/**
\file
Deklaracje wymagane do komunikacji pomidzy wtyczkami.
*/

// -----------------------------------------------------------------------------------------------
/**
\defgroup gr_shared Komunikacja pomidzy wtyczkami.

Nagwek powinien by doczony do kodu wtyczki poprzez plug_export.h .
\{
*/


  #ifndef PLUGSHAREDH
  #define PLUGSHAREDH

  #define KONNEKT_SDK_V 2 ///< wydanie SDK

  #pragma pack(push, 1)
  #define IMPARAM int
  #define tIMP IMPARAM
  /** Struktura uywana podczas przesyania wiadomoci.
    Jest uywana jako bazowa dla wikszych struktur...
  */
  struct sIMessage_base {
    unsigned short s_size; ///< Rozmiar struktury w bajtach (zazwyczaj ustawiane przez kontruktor)
    unsigned int id;   ///< Identyfikator wiadomoci
    unsigned int flag; ///< Flaga wiadomoci (na razie powinno by zawsze rwne 0)
    int net;  ///< Docelowa sie. 0 - rdze lub UI
    unsigned int type; ///< Docelowy typ wtyczek
    unsigned int sender; ///< Identyfikator wtyczki wysyajcej
    sIMessage_base(unsigned int _id, int _net, unsigned int _type)
        :s_size(sizeof(sIMessage_base)),id(_id),net(_net),type(_type),sender(0),flag(0) {}
    sIMessage_base() 
        :s_size(sizeof(sIMessage_base)),id(0),net(0),type(0),sender(0),flag(0) {}
    sIMessage_base(unsigned int _id)
        :s_size(sizeof(sIMessage_base)),id(_id),net(0),type(0),sender(0),flag(0) {}
    sIMessage_base(sIMessage_base * base) {*this = *base;}


  };
  /** Struktura uywana podczas przesyania wiadomoci.
    Moe by struktur bazow dla wikszych struktur ...
    p1 i p2 mog by zastpione dowolnymi typami, najlepiej o
    rozmiarze po 4 bajty ...
  */
  struct sIMessage_2params: public sIMessage_base {
    IMPARAM p1;   ///< Parametr pierwszy
    IMPARAM p2;   ///< Parametr drugi

    sIMessage_2params(unsigned int _id, int _net, unsigned int _type, IMPARAM _p1, IMPARAM _p2)
        :sIMessage_base(_id , _net, _type), p1(_p1),p2(_p2) {s_size=sizeof(sIMessage_2params);}
    sIMessage_2params()
        :sIMessage_base(), p1(0),p2(0) {s_size=sizeof(sIMessage_2params);}
    sIMessage_2params(unsigned int _id, IMPARAM _p1, IMPARAM _p2) 
        :sIMessage_base(_id), p1(_p1),p2(_p2) {s_size=sizeof(sIMessage_2params);}
    sIMessage_2params(sIMessage_base &base) 
        :sIMessage_base(base.id , base.net , base.type), p1(0),p2(0) 
        {s_size=sizeof(sIMessage_2params);
         this->flag = base.flag;
         this->sender = base.sender;}
  };
  typedef sIMessage_2params sIMessage;
  typedef sIMessage sIMESSAGE;
  #define sIMessage_V1 30 ///< Rozmiar tej struktury w wersji 1 SDK

  typedef IMPARAM (__stdcall*fIMessageProc)(sIMessage_base * msg);

#ifndef _WINDOWS_
    #define HANDLE void *
    #define HINSTANCE void *
    #define HWND void *
#endif

    /**Klasa suca do komunikowania si z "rdzeniem" systemu wtyczek.

    Adres tej struktury (zaalokowanej w rdzeniu) przekazywany jest
    jako parametr w pierwszej wiadomosci do wtyczki - #IM_INIT ...<br>
    Kada wtyczka posiada wasn kopi cCtrl.
    \sa IMessageProc()
  */
  class cCtrl {
        public:
         virtual int __stdcall getLevel()=0;  ///< Zwraca "poziom" dostepu do rdzenia. W 99% przypadkw zwrci 1 ...
         virtual unsigned int __stdcall ID()=0;  ///< Zwraca identyfikator wtyczki.
         virtual HINSTANCE __stdcall hInst()=0;   ///<  Zwraca uchwyt procesu (HINSTANCE).
         virtual HINSTANCE __stdcall hDll()=0;   ///<  Zwraca uchwyt biblioteki wtyczki.

         virtual int __stdcall getError()=0; ///< Zwraca kod ostatniego bdu.
         virtual void __stdcall setError(int err_code)=0; ///< Ustawia kod bdu.
                         ///  Powinien byc ustawiony gdy wystapil blad przy ODBIORZE wiadomosci (np wiadomosc jest nieobslugiwana).
                         ///  \sa ImessageProc() imerror_
         virtual bool __stdcall isRunning()=0; ///< Zwraca 0 jeli program jest w trakcie zamykania.
                                               ///  adne dusze operacje nie powinny by wykonywane. Cz IMessages
                                               ///  w innych moduach i tak nie zostanie wykonana...
         /**
         Wysya wiadomo do wtyczek.
         Aby przesa wiadomo do rdzenia lub ui jako \i net i \i type trzeba poda 0
         \param msg Wiadomo do przesania
         \sa im_ net_ imt_
         */
         virtual int __stdcall IMessage(sIMessage_base * msg) = 0;
         /**  Wysya wiadomo bezporednio do okrelonej wtyczki.
         \param msg Wiadomo do przesania
         \param plug ID wtyczki
         \sa im_ imc_plug_
         */
         virtual int __stdcall IMessageDirect(unsigned int plug , sIMessage_base * msg)=0;
         /** Zamienia (lub nie) identyfikator wiersza na jego numer.
         */
         virtual int __stdcall DTgetPos(char db , unsigned int row)=0;
         /** Zamienia (lub nie) numer wiersza na jego identyfikator.
         */
         virtual int __stdcall DTgetID(char db , unsigned int row)=0;
         virtual int __stdcall DTgetOld(char db , unsigned int row , unsigned int col)=0;
         virtual int __stdcall DTsetOld(char db , unsigned int row , unsigned int col , int val , int mask=0)=0;
         /** Pobieta typ kolumny \a id.
         \param id Identyfikator kolumny
         \return typ kolumny
         \sa \ref cfg dt_ct_
         */
         virtual int __stdcall DTgetType(char db , unsigned int id)=0;
         /** Pobieta ilo wierszy w tablicy.
         \param db Identyfikator tablicy
         \sa \ref cfg dt_ct_
         */
         virtual int __stdcall DTgetCount(char db)=0;
         /** Pobieta identyfikator kolumny o podanej nazwie.
         \param db Identyfikator tablicy
         \param name nazwa kolumny
         \sa \ref cfg dt_ct_
         */
         virtual int __stdcall DTgetNameID(char db , const char * name)=0;

         virtual bool __stdcall Is_TUS(unsigned int thID)=0; ///< Zwraca \b true jeli aktualny wtek jest rny od \t thID.
         virtual int __stdcall RecallTS(HANDLE th = 0 , bool wait = 1)=0;
         virtual int __stdcall RecallIMTS(HANDLE th , bool wait , sIMessage_base * msg , int plugID)=0;

         virtual void __stdcall WMProcess()=0; ///< Oprnienie kolejki wiadomoci windowsowych.
                                               ///  Powinno by wykonywane TYLKO w gwnym wtku, w dugich
                                               ///  blokujcych ptlach (aby odwiey wygld okien)
         virtual void * __stdcall GetTempBuffer(unsigned int size)=0; ///< Zwraca wskanik do bufora tymczasowego o rozmiarze \a size.
                                                /// Bufor alokowany jest w kontekcie wtyczki i wtku.
                                                /// \attention Nie mona zwalnia tej pamici!

         /** Pobiera wartosc wiersza z tablicy danych z konwersj typw.
         Konwersja odbywa si gdy sDTValue::type jest rny od DT_CT_UNKNOWN. W
         przeciwnym wypadku jako typ przyjmowany jest typ kolumny.
         \param db Identyfikator tabeli
         \param row Identyfikator/numer wiersza
         \param col Identyfikator kolumny
         \param value Struktura z wartoci
         \return warto (lub adres do wartoci jeli typ != DT_CT_INT)
         \attention W #DTMSG mona zapisywa tylko w okrelonych okolicznociach!
         */
         virtual bool __stdcall DTget(char db , unsigned int row , unsigned int col , struct sDTValue * value)=0;
         /** Ustawia wartosc wiersza z tablicy danych z konwersj typw.
         Konwersja odbywa si gdy sDTValue::type jest rny od DT_CT_UNKNOWN. W
         przeciwnym wypadku jako typ przyjmowany jest typ kolumny.
         \param db Identyfikator tabeli
         \param row Identyfikator/numer wiersza
         \param col Identyfikator kolumny
         \param value Struktura do ktrej zostanie zapisana warto.
         \attention Do odczytu danych z #DTMSG przygotowane s inne funkcje!
         */
         virtual bool __stdcall DTset(char db , unsigned int row , unsigned int col , struct sDTValue * value)=0;
         /** Blokuje dostp do wiersza w tablicy dla innych wtkw. Zaraz po
         wykorzystaniu zabezpieczonych danych trzeba wywoa cCtrl::DTunlock z tymi
         samymi parametrami!
         \param db Identyfikator tabeli
         \param row Identyfikator/numer wiersza, lub -1 jeli chcemy zablokowa CA tablic
         \param reserved Zarezerwowane na pniej, musi by rwne 0.
         \return Ilo wczeniej zaoonych blokad.
         */
         virtual unsigned short __stdcall DTlock(char db , unsigned int row , int reserved=0)=0;
         /** Odblokowuje dostp do wiersza w tablicy dla innych wtkw,
         zastrzeony wczeniej przy uyciu cCtrk::DTlock.
         \param db Identyfikator tabeli
         \param row Identyfikator/numer wiersza, lub -1 jeli chcemy zablokowa CA tablic
         \param reserved Zarezerwowane na pniej, musi by rwne 0.
         \return Ilo pozostaych blokad.
         \attention Po wykonaniu tej funkcji, wszystkie zwrcone wskaniki
         bezporednie mog by ju nieaktualne!
         */
         virtual unsigned short __stdcall DTunlock(char db , unsigned int row , int reserved=0)=0;
         /** Wszystkie bufory wrzucane do API, eby mogby by zwolnione
          w innym module musz by zaalokowane ponisz funkcj. */
         virtual void * __stdcall malloc(size_t size)=0; 
         /** Wszystkie bufory tekstowe wrzucane do API, eby mogby by zwolnione
          w innym module musz by zaalokowane ponisz funkcj. */
         virtual char * __stdcall strdup(const char * str)=0;
         /** Wszystkie bufory zaalokowane przez cCtrl::malloc i cCtrl::strdup
         powinny by zwolnione t funkcj. */
         virtual void __stdcall free(void * buff)=0;

         /** Uywanie zwykego Sleep w gwnym wtku najprdzej doprowadzi
             K do stanu chwilowej nieuywalnoci, bardzo moliwe rwnie,
             e nastpi zupeny DeadLock.
             Zamiast tego mona uywa tej funkcji, ktra po prostu zamiast Sleep
             wywouje MsgWaitForMultipleObjectsEx. Nie jest wic gwarantowane, 
             e podany czas w ogle minie. Trzeba pamita te, e nie jest gwarantowane,
			 e aktualny wtek nie wykona gdzie po drodze innego kodu w wyniku
			 wywoania f-cji APC, timer'a czy windowsowej wiadomoci...
             Generalnie, jeeli musisz czeka na co w gwnym wtku, uywaj
             MsgWaitForMultipleObjectsEx w poczeniu z Ctrl->WMProcess, ktre
             przeglda kolejk oczekujcych wiadomoci w aktualnym wtku.
         */
         virtual int __stdcall Sleep(unsigned int time)=0;
		 
		 /**
		     BeginThread dziaa identycznie jak _beginthreadex z wyjtkiem
			 tego, e w trybie debug potrafi wychwytywa bdy w wtku
			 i je raportowa... Uywanie wysoko zalecane!
		 */
		 virtual unsigned int __stdcall BeginThread(void *security,
			unsigned stack_size,
			unsigned ( __stdcall *start_address )( void * ),
			void *arglist=0,
			unsigned initflag=0,
			unsigned *thrdaddr=0
		 )=0;

         // funkcje lokalne, dla ulatwienia
         int DTgetInt(char db , unsigned int row , unsigned int col);
         bool DTsetInt(char db , unsigned int row , unsigned int col , int value , int mask = -1);
         char * DTgetStr(char db , unsigned int row , unsigned int col , char * buff = 0 , unsigned int size = 0);
         bool DTsetStr(char db , unsigned int row , unsigned int col , const char * value);
         __int64 DTgetInt64(char db , unsigned int row , unsigned int col);
         bool DTsetInt64(char db , unsigned int row , unsigned int col , __int64 value , __int64 mask = -1);


  };


  #define DTCFG  0x0  ///< Tablica konfiguracji.
  #define DTCNT  0x1  ///< Tablica kontaktw.
  #define DTMSG  0x2  ///< Tablica wiadomoci.
  #define DTNONE -1
  class cKException { // Wyjtek
  public:
      const char * info;
      cKException(const char * info):info(info) {}
  };

  class cKException_Msg:public cKException { // Wyjtek
  public:
      const struct sIMessage_base * msg;
      cKException_Msg(const char * info , const sIMessage_base * msg):cKException(info), msg(msg) {}
  };


  typedef signed int tNet;

// -----------------------------------------------------------------------------------------------
  /** \defgroup net_ Sieci wtyczek
      \brief \no

      "Sie" (Net) wtyczki oznacza przynaleno do pewnej grupy.
      Na przykad jeden protok moe by obsugiwany przez kilka niezalenych
      od siebie wtyczek o tej samej wartoci \a Net. <br> <br>
      Warto sieci uywana jest przede wszystkim podczas komunikacji
      pomidzy wtyczkami. W momencie wysania #IMessage , rdze
      szuka wtyczki o podanej wartoci \a Net obsugujcej typ wysyanej
      wiadomoci. W ten sposb , mona rozsya w systemie wiadomoci
      do \i wtyczek nawet nie wiedzc o ich istnieniu (a przede wszystkim
      o ich identyfikatorach) ...<br><br>
      Numery sieci gotowych wtyczek bd doczane do SDK...

      \attention \a Net jest typu <b>unsigned int</b> , przy czym
              wartoci zdefiniowane przez uytkownika powinny by wiksze od 127
      \sa info imt_ #IM_PLUG_NET
  \{
  */
     #define NET_FIRST -2          ///< Wiadomo dotrze do pierwszej wtyczki (dowolnej sieci), ktra potrafi j obsuy.
     #define NET_BROADCAST -1      ///< Wiadomo dotrze do wtyczek wszystkich sieci.
     #define NET_BC NET_BROADCAST  ///< Odpowiednik #NET_BROADCAST.
     #define NET_NONE 0            ///< Wiadomosci do rdzenia.
     #define NET_NET 1             ///< Wtyczki obsugujce protok "wasny".
     #define NET_INTERNAL 2
     #define NET_SOUND 3           ///< Dwik
     #define NET_UPDATE 4           ///< Update
     #define NET_OTHER   6         ///< Wtyczki nie posiadajce akcji, nie obsugujce wiadomoci itp.

     #define NET_GG  10            ///< Wtyczki obsugujce protok GG
     #define NET_ICQ 11            ///< Wtyczki obsugujce protok ICQ
     #define NET_TLEN 12            ///< Wtyczki obsugujce protok TLEN
     #define NET_EMAIL 13            ///< Wtyczki obsugujce EMaile
     #define NET_SMS 14            ///< Wtyczki obsugujce SMSy
	 #define NET_KLAN 15 
	 #define NET_KSTYLE 16

  // Inne wtyczki
     #define NET_WAPILOT 756       ///< WApilot.dll

  /** \} */  // net_

  // Typy IMessage

// -----------------------------------------------------------------------------------------------
  /** \defgroup imt_ Definicje typw IMessage ...
    \brief \no

    Kada wtyczka powinna zdefiniowa jakiego typu #IMessage potrafi
    przyj (konkretniej - za co ma odpowiada).<br><br>
    Typy mona czy poprzez '|' (OR). <br><br>
    IMessage() wywoany z \a typem innym od #IMT_ALL zostanie
    wysany tylko do wtyczek z zadeklarowan obsug wybranego \a typu.

    \sa #IM_PLUG_NET IMessage()
    \{
  */
        typedef unsigned int tIMtype;

        /// Wszystkie typy.
        #define IMT_ALL 0xFFFFFFFF
        /// Wiadomo bezporednio do rdzenia (lub UI).
        #define IMT_CORE        0

        /// Wiadomoci tekstowe.
        #define IMT_MESSAGE     1
        /// Protok sieciowy.
        #define IMT_PROTOCOL    2
        /// Kontakty.
        #define IMT_CONTACT     4
        /// Konfiguracja.
        #define IMT_CONFIG      8
        /// Interfejs Uytkownika (uywanie wtyczki UI).
        #define IMT_UI          0x10
        /** Wtyczka obsuguje kontakty caej swojej sieci.
            \attention Ustawienie tego typu spowoduje dodanie nazwy sieci (#IM_PLUG_NETNAME)
            do list sieci w opcjach kontaktu (np. dodawanie , ignorowanie itp.)<br>
            Tylko \b jedna wtyczka z caej sieci moe mie ten typ ustawiony!!!
            \sa #IM_PLUG_NETNAME \ref cnt
            */
        #define IMT_NET         0x20  // Rozpoznaje kontakty danej sieci (podczas dodawania , edycji)
        /** Wtyczka obsuguje wyszukiwanie kontaktw w swojej sieci.
            \attention Podobnie jak w #IMT_UI Ustawienie tego typu spowoduje dodanie nazwy sieci (#IM_PLUG_NETNAME)
            do list sieci w wyszukiwarce kontaktw<br>
            Tylko \b jedna wtyczka z caej sieci moe mie ten typ ustawiony!!!
            \sa #IM_PLUG_NETNAME \ref cnt
            */
        #define IMT_NETSEARCH   0x40
        /// Wtyczka wykorzystuje system obsugi wiadomoci tekstowych zawarty w UI.
        #define IMT_MSGUI       0x80
        /// Kontakty w sieci posiadaj UID (UserID)
        #define IMT_NETUID      0x100
        /// Otrzyma w IM_MSG_RCV wszystkie wiadomoci , niezalenie od \ref net_ "NET".
        #define IMT_ALLMESSAGES 0x200
        /// Bdzie otrzymywa IM_MSG_ACK.
        #define IMT_MESSAGEACK 0x400
        /** \} */ // imt_

// -----------------------------------------------------------------------------------------------
  /** \defgroup gr_im Identyfikatory IMessage
    \brief \no

    Identyfikator jest \i nazw przesyanej #IMessage (wiadomoci
    wewntrznej).
    \par
    Wiadomoci dziel si na (pod wzgldem przeznaczenia):
    - IMC_* \ref imc_ od 0 do 10000 #IMI_BASE
    - IMI_* \ref imi_ od 10000 #IMI_BASE do 20000 #IM_BASE
    - IM_*  \ref im_  od 20000 #IM_BASE do 0xFFFFFFFF
    \attention Wiadomoci \ref imc_ dotr \b tylko do \ref core "rdzenia". (niezalenie od wybranego \a net i \a type w IMessage())
    \attention Wiadomoci \ref imi_ dotr \b tylko do \ref ui "UI". (niezalenie od wybranego \a net i \a type w IMessage())
    \attention Wiadomoci \ref im_ < #IM_SHARE mog by wysyane \b tylko przez \ref core "rdze" i \ref ui "ui".
    \attention Wiadomoci \ref im_ deklarowane przez uytkownika powinny by tworzone jako #IM_USER + numer (numer najlepiej jako NET * 1000).
    \attention Parametry podawane s w kolejnoci - P1 , P2.

    Wiadomoci utworzone na potrzeby powstajcych wtyczek powinny
    by umieszczane w nazwa_wtyczki_shared.h tak, aby inni mogli
    wykorzystywa API wtyczki.

    \sa IMessageProc()
  \{
  */

     typedef unsigned int tIMid;

     #define IMI_BASE 10000 ///< Od tej granicy zaczynaj si wiadomoci do \ref ui "UI".
     #define IM_BASE  20000 ///< Od tej granicy zaczynaj si wiadomoci do \ref plug "wtyczek" wysyane tylko przez \ref core "rdze" i \ref ui "UI".
     #define IM_SHARE 30000 ///< Od tej granicy zaczynaj si wiadomoci do \ref plug "wtyczek".
     #define IM_USER  40000 ///< Od tej granicy zaczynaj si wiadomoci do \ref plug "wtyczek" zdefiniowane przez uytkownika.

// -----------------------------------------------------------------------------------------------
     /**
       \defgroup im_ do Wtyczek
       \brief \no

       \{
     */

         // Inicjalizacja DLL'a
         #define IM_PLUG_NET       IM_SHARE+10     ///< Zwraca warto NET wtyczki.
         #define IM_PLUG_TYPE      IM_SHARE+11     ///< Zwraca wartoci IMT_ wtyczki.
         #define IM_PLUG_VERSION   IM_SHARE+12     ///< Zwraca opis wersji wtyczki.
         #define IM_PLUG_SIG       IM_SHARE+13     ///< Zwraca sygnatur wtyczki.
         #define IM_PLUG_CORE_V    IM_SHARE+14     ///< Zwraca wymagan sygnatur rdzenia (lub 0).
         #define IM_PLUG_UI_V      IM_SHARE+15     ///< Zwraca wymagan sygnatur UI (lub 0).
         #define IM_PLUG_NAME      IM_SHARE+16     ///< Zwraca nazw wtyczki.
         #define IM_PLUG_NETNAME   IM_SHARE+17     ///< Zwraca nazw sieci obsugiwanej przez wtyczk (lub 0).
         #define IM_PLUG_CERT      IM_BASE+18      ///< Zastrzeone dla wtyczek specjalnych.
         #define IM_PLUG_INFO      IM_BASE+19     ///< Wtyczka moe zalogowa informacj o swoim "stanie".
         #define IM_PLUG_SDKVERSION IM_BASE+20     ///< Zwraca #KONNEKT_SDK_V.

         #define IM_PLUG_PRIORITY  IM_BASE+21     ///<Wtyczka podaje swj priorytet w kolejkach (im wyszy, tym znajdzie si wczeniej).
                                                   /// Wszystkie "zwyke" wtyczki mog nie obsugiwa tej wiadomoci, lub po prostu zwraca 0 (ich priorytet zostanie ustawiony na PLUGP_STANDARD.
                                                   /// Dwie wtyczki o tym samym priorytecie ustawiane s w kolejnoci uytkownika.
                                                   /// Jeeli twoja wtyczka nie jest uzaleniona od kolejnoci, NIE ustawiaj jej!
                                                   /// Dziki priorytetom wiadomoci mog by obsugiwane w odpowiedniej kolejnoci.
                                                   /// \return (PLUGP_enum) pozycja
     /* Grupy priorytetw dla #IM_PLUG_PRIORITY */
     enum PLUGP_enum {
         PLUGP_LOWEST = 0x10,  /// Koniec listy
         PLUGP_LOW = 0x40,  
         PLUGP_STANDARD = 0x80, /// Zwyke wtyczki
         PLUGP_HIGH = 0xB0,  
         PLUGP_HIGHEST = 0xE0,  /// Pocztek listy
         PLUGP_NONE = 0x0  /// W efekcie to samo co PLUGP_STANDARD
     };


         #define IM_PLUG_INIT      IM_BASE+1
         /**< Inicjalizacja wtyczki. Pierwszy przesany IMessage nakazujcy wtyczce inicjalizacj kodu.
                 \param cCtrl adres struktury sterujcej
                 \param ID identyfikator wtyczki
         */

         #define IM_PLUG_DEINIT    IM_BASE+2      ///< Za chwil uchwyt do wtyczki zostanie zwolniony. Najlepszy moment eby posprzta.
         #define IM_PLUG_INITEX    IM_BASE+3      ///< Zastrzeone dla wtyczek specjalnych.

         #define IM_PLUG_UPDATE    IM_BASE+30     ///< Ta wersja wtyczki uruchamiana jest w tym profilu po raz pierwszy.
                                                   ///  \param p1 (int) Poprzednia wersja, lub 0. 
                                                   ///  Format wersji to w hexie: MNNRRBBB - Major, miNor, Release, Build.
                                                   ///  W plug_func.h mona znale makra do szybkiego wycigania tych wartoci. 
         #define IM_GET_STATUS     IM_SHARE+31    ///< Jeeli wtyczka obsuguje sie, powinna zwrci swj aktualny status.
                                                    /// \return (int) status
         #define IM_GET_STATUSINFO IM_SHARE+32    ///< Jeeli wtyczka obsuguje sie, powinna zwrci swj aktualny opis statusu.
                                                    /// \return (const char *) opis statusu


         #define IM_NEW_PROFILE    IM_BASE + 40   ///< Oznacza pierwsze uruchomienie danego profilu. Najlepszy moment eby si przywita.
         #define IM_CANTQUIT       IM_BASE + 41   ///< Zwrcenie \i true spowoduje anulowanie zamykania programu.
         #define IM_PASSWORDCHANGED IM_BASE + 42  ///< Oznacza zmian hasa dla profilu.

		 #define IM_THREADSTART    IM_BASE + 43 ///< Aktualny wtek wanie zosta uruchomiony. Lepiej polega jednak na DllMain!
	 	 #define IM_THREADEND	   IM_BASE + 44 ///< Aktualny wtek wanie si koczy. Lepiej polega jednak na DllMain!

		 #define IM_MSG_RCV       IM_BASE+100
         /**< Wtyczka powinna sprawdzi czy obsuguje dany typ wiadomoci.
           Wtyczki odpytywane s "od koca". Ostatnia, ktra zwrci
           IM_MSG_RCV_ok bdzie otrzymywa rwnie IM_MSG_OPEN.
           \param p1 (cMessage *) wiadomo.
           \param p2 (bool) \i true - wiadomo wanie przysza , \i false - wiadomo zostaa zaadowana z pliku.
           \return (int) Poczone flagi \ref im_msg_, lub 0 jeli nie obsuguje takich wiadomoci.
         */
         #define IM_MSG_SEND      IM_SHARE+100 /**< Wiadomo powinna zosta wysana.
           \param p1 (cMessage *) Wiadomo
           \return Jeli si udao powinno zrci \ref im_msg_.
         */
         #define IM_MSG_OPEN      IM_SHARE+101    /**< Wiadomo powinna zosta otwarta.
           \param p1 (cMessage *) Wiadomo
           \return Jeli si udao powinno zrci \ref im_msg_.
         */
         #define IM_MSG_ACK      IM_BASE+102    /**< Potwierdzenie wysania wiadomoci.
           \param p1 (cMessageAck *) Potwierdzenie. ID jest ustawiony na ID potwierdzanej wiadomoci (ktra jeszcze siedzi w kolejce i mona j odczyta).
         */

         /** @defgroup im_msg_ Zwroty z IM_MSG_* 
             #IM_MSG_RCV , #IM_MSG_SEND i #IM_MSG_OPEN mog zwrci poczone
             takie flagi.
             @{
            */
            #define IM_MSG_ok     1 ///< Flaga zwrotna #IM_MSG_RCV - Musi by ustawiona jesli wtyczka zamierza obsuy wiadomo.
            #define IM_MSG_delete 2 ///< Wiadomo powinna zosta niezwocznie usunita...
            #define IM_MSG_update 4 ///< Zawarto wiadomoci zostaa zmieniona i powinna zosta zaktualizowana jej kopia w kolejce.
            #define IM_MSG_processing 8 ///< Flaga zwrotna #IM_MSG_OPEN i #IM_MSG_SEND - Wiadomo jest dalej przetwarzana (np w osobnym wtku) i zostanie usunita z kolejki poprzez #IMC_MESSAGEREMOVE,
                                         ///  lub zakoczy przetwarzanie poprzez #IMC_MESSAGEPROCESSED.
         /** @} */
         #define IM_MSG_CHARLIMIT IM_BASE+105    ///< Zapytanie o limit znakw na wiadomo
                                            ///  \return Limit iloci znakw na wiadomo. 0 - bez limitu
         // Config (IMT_CONFIG)
         #define IM_SETCOLS  IM_BASE+1001   ///< W tym momencie wtyczka powinna zadeklarowa wszystkie kolumny w tablicach.

         #define IM_CFG_SAVE      IM_BASE+1010 ///< Ustawienia zaraz zostan zapisane do pliku.
         #define IM_CFG_LOAD      IM_BASE+1011 ///< Ustawienia zostay wczytane.
         #define IM_CFG_CHANGED   IM_BASE+1020 ///< Ustawienia zostaly zmienione przez uytkownika.
         // UI
         #define IM_UI_PREPARE    IM_BASE+2000 ///< Najlepszy moment aby przygotowa interfejs (np zdefiniowa Akcje).

         #define IM_START         IM_BASE+2100 ///< Wtyczka powinna wystartowa.
         #define IM_END           IM_BASE+2101 ///< Wtyczka powinna zakoczy dziaanie.

         #define IM_UIACTION      IM_BASE+2200 ///< Powiadomienie o zdarzeniu w akcji.
                                               /// \param p1 (cUIActionNotify *) Powiadomienie.

         //  IMT_PROTOCOL
         #define IM_CONNECT       IM_SHARE+3000 ///< Mona zacz si czy.
         #define IM_DISCONNECT    IM_SHARE+3001 ///< Trzeba si rozczy.
         #define IM_AWAY          IM_SHARE+3002 ///< Program wchodzi w tryb Auto-Away.
         #define IM_BACK          IM_SHARE+3003 ///< Program powraca z trybu Auto-Away.
         #define IM_NEEDCONNECTION IM_BASE+3004 ///< Wysyana do kontrolek zaraz po wczeniu
                                           ///  automatycznych pocze i na chwil przed
                                           ///  wykonaniem pierwszego testu na istnienie poczenia.
                                           ///  \attention W tej wiadomoci #IMC_SETCONNECT
                                           ///  powinny wywoywac wtyczki ktre ZAWSZE potrzebuj pocze
                                           ///  (niezalenie od ustawienia #CFG_AUTOCONNECT).<br>
                                           ///  Pozostae powinny zgosi #IMC_SETCONNECT np. w #IM_PREPARE.

        #define  IM_CHANGESTATUS  IM_SHARE+3005  ///< Jeeli wtyczka obsuguje sie, powinna zmieni swj status...
                                                 /// \param p1 (int) status (lub -1 jeli nie zmieniamy)
                                                 /// \param p2 (char*) opis (lub 0 jeli nie zmieniamy)
        #define  IM_ISCONNECTED   IM_SHARE+3006  ///< Trzeba zwrci 1 jeli jestemy poczeni.

         #define IM_CNT_UPLOAD    IM_SHARE+4000  ///< Informacje o kontakcie \a p1 zostay zmienione i moga by np. zapisane na serwerze.
                                                 /// \param p1 (int) ID kontaktu do wysania
         #define IM_CNT_DOWNLOAD  IM_SHARE+4001  ///< Informacje o kontakcie \a p1 powinny zosta zaktualizowane (np. pobrane z serwera).
                                                 /// \param p1 (int) ID kontaktu do pobrania
                                                 /// \param p2 (bool) 0 - info powinno zosta zapisane bezporednio w tabeli. 1 - info powinno by ustawione 
                                                 ///  jako wartoci akcji.

         #define IM_CNT_REMOVE    IM_BASE+4002  ///< Kontakt zaraz zostanie usunity.
                                                 ///  \param p1 (int) ID kontaktu
                                                 ///  \param p2 (bool) true - usunicie zostao potwierdzone przez uzytkownika.
         #define IM_CNT_REMOVED    IM_BASE+4005 ///< Kontakt zosta usuniety.
                                                 ///  \param p1 (int) ID kontaktu
                                                 ///  \param p2 (bool) true - usunicie zostao potwierdzone przez uzytkownika.
         #define IM_CNT_ADD       IM_BASE+4003  ///< Kontakt zosta dodany
                                                 ///  \param p1 (int) ID kontaktu
         #define IM_CNT_ADDING    IM_BASE+4004  ///< Kontakt jest w trakcie tworzenia (ktre moe zosta ew. przerwane)
                                                 ///  Parametry kontaktu nie s jeszcze ustalone.
                                                 ///  \param p1 (int) ID kontaktu
         #define IM_CNT_SEARCH    IM_BASE+4010  ///< danie szukania kontaktu (np. w katalogu sieci)
                                                 ///  \param p1 (sCNTSEARCH *) parametry wyszukiwania
         #define IM_CNT_CHANGED   IM_BASE+4006  ///< Istotna cecha kontaktu (np. UID) zostaa zmieniona.
                                                 ///  Przesyane przy pomocy sIMessage_CntChanged.
                                                 ///  Jeeli przecastujesz to na sIMessage_2params to \a p1 jest ID kontaktu.

         /** Struktura do przesyania #IM_CNT_CHANGED.*/
            struct sIMessage_CntChanged:public sIMessage_base {
                unsigned int _cntID; ///< ID kontaktu
				union {
					///< Oznacza co zostao zmienione. W tej chwili
					struct {
						unsigned net : 1;
						unsigned uid : 1;
					} _changed; 
					unsigned int _changed_bitmap;
				};
                unsigned int _oldNet; ///< Poprzednia warto net tego kontaktu
                const char * _oldUID; ///< Poprzednia warto UID
                sIMessage_CntChanged(int msgID , int cntID):sIMessage_base(msgID),_cntID(cntID),_changed_bitmap(0),_oldNet(NET_NONE),_oldUID(0){s_size=sizeof(*this);}
                sIMessage_CntChanged(const sIMessage_base * base){
                    if (base->s_size == sizeof(*this)) {
                        *this = *(const sIMessage_CntChanged*)(base);
                    } else if (base->s_size >= sizeof(sIMessage_2params)) {
                        this->flag = base->flag;
                        this->id = base->id;
                        this->net = base->net;
                        this->sender = base->sender;
                        this->type = base->type;
                        this->s_size = sizeof(*this);
                        this->_cntID = ((const sIMessage_2params*)(base))->p1;
                        this->_changed_bitmap = ((const sIMessage_2params*)(base))->p2;
						this->_oldNet = NET_NONE;
						this->_oldUID = 0;
                    } else throw 0;
                }
            };

         #define IM_CNT_STATUSCHANGE IM_BASE+4011 ///< Status kontaktu zaraz ulegnie zmianie.
                                             ///  sIMessage_StatusChange *

         #define IM_STATUSCHANGE IM_BASE+4012 ///< Status wtyczki zaraz ulegnie zmianie.
                                             ///  sIMessage_StatusChange *

         /** Struktura do przesyania #IM_CNT_STATUSCHANGE i #IM_STATUSCHANGE.*/
            struct sIMessage_StatusChange:public sIMessage_base {
                union {
                    unsigned int cntID; ///< ID kontaktu
                    unsigned int plugID; ///< ID wtyczki zmieniajcej status.
                };
                unsigned int status; ///< Nowy status, ktry zaraz zostanie ustawiony. -1 oznacza brak zmiany.
                const char * info; ///< Nowy opis statusu, ktry zaraz zostanie ustawiony. 0 oznacza brak zmiany.

                sIMessage_StatusChange(int msgID , int cntID , unsigned int status, const char * info):sIMessage_base(msgID),cntID(cntID),status(status),info(info){s_size=sizeof(*this);}
                sIMessage_StatusChange(const sIMessage_base * base) {
                    if (base->s_size < sizeof(*this)) throw cKException_Msg(0 , base);
                    *this = *(sIMessage_StatusChange*)base;
                    s_size=sizeof(*this);
                }
            };


         #define IM_GRP_CHANGED   IM_BASE+4020 ///< Lista grup ulega zmianie.
         #define IM_IGN_CHANGED   IM_BASE+4021 ///< Lista ignorowanych kontaktw ulega zmianie.
                                                /// \param p1 (int) sie >0 - kontakt zosta dodany, <0 - usunity
                                                /// \param p2 (char*) 

    
         /** Parametry wyszukiwania/wyniki wyszukiwania.
            Struktura wykorzystywana zarwno podczas wysyania zapytania, jak i zwracania wynikw.
         */
         struct sCNTSEARCH {
            unsigned short s_size; ///< Musi zawiera rozmiar struktury. Ustawiany przez kontruktor.
            int status;   ///< Podczas szukania - 1 - szukaj tylko online. Podczas zwracania - status kontaktu.
            char uid      [21] /// UID
                ,name     [51] /// Imi
                ,surname  [51] /// Nazwisko
                ,nick     [51] /// Ksywa
                ,city     [51] /// Miasto
                ,email    [101]/// Email
                ,phone    [51] /// Telefon
                ,other    [101] /// Inne (tylko w odpowiedzi)
                ;
            int gender; ///< Pe 0 - nieznana , 1 - mczyzna , 2 - kobieta
            int born_min; ///< Urodzony, OD roku
            int born_max; ///< Urodzony, DO roku
            int net;    ///< Numer sieci.
            int start;  ///< Od jakiej pozycji pokazywa dalej.
                        /// Przy zwracaniu, ostatni znaleziony kontakt powinien mie ustawiony \start
                        /// na pozycj od ktrej mona wznowi wyszukiwanie.
            HANDLE handle; ///< Uchwyt do okna wyszukiwania
            sCNTSEARCH() {s_size=sizeof(sCNTSEARCH);start=0;handle=0;net=0;gender=0;born_min=0;
                uid[0]=0;
                name[0]=0;
                surname[0]=0;
                nick[0]=0;
                city[0]=0;
                email[0]=0;
                phone[0]=0;
                other[0]=0;
            }
         };
         #define sCNTSEARCH_V1 496
  /** \} */  // Wiadomoci do WTYCZEK

// -----------------------------------------------------------------------------------------------
  /**
    \defgroup imc_ do Rdzenia
    \brief \no

    \{
  */
        #define IMC_LOG              1 ///< Jeeli program jest debugowany , zapisuje tekst w konnekt.log . Wiadomo nie jest rozpoznawana przez Core (wiec ustawi blad!)
                                        ///  \param p1 (char*) tekst.
        #define IMC_GETPROFILE       2 ///< Zwraca nazw profilu.
                                        ///  \return (char *)

        #define IMC_DEBUG            3 ///< Otwiera okno developera
        #define IMC_ISDEBUG          4 ///< Zwraca true gdy jest w trybie developera.
        #define IMC_ISBETA           9 ///< Zwraca true gdy jest w trybie beta.
        #define IMC_BETA             40 ///< Otwiera okno beta-testera
        #define IMC_REPORT           41 ///< Otwiera okno raportowania
        #define IMC_PLUGS            42 ///< Otwiera okno wtyczek
        #define IMC_NET_TYPE         43 ///< Pobiera czn warto flag typw (#IM_PLUG_TYPE) ze wszystkich wtyczek danej sieci.
                                         ///  \param p1 (int) sie

        #define IMC_ARGC             5 ///< Zwraca liczb parametrw przekazanych do programu.
        #define IMC_ARGV             6 ///  Zwraca parametr \a p1. 
								        ///  \param p1 (int) numer parametru
								        ///  \return (char*) 

        #define IMC_ISWINXP          60 ///< Zwraca 1, jeli korzystamy z ComCtl6 na winXP.
        #define IMC_ISNEWPROFILE     61 ///< Zwraca 1, gdy jest to pierwsze uruchomienie na tym profilu.  
        #define IMC_ISNEWVERSION     62 ///< Zwraca 1, gdy jest to pierwsze uruchomienie na nowej wersji.
                                         ///  \warning Wynik jest mao miarodajny i moe by faszywy! Wiarygodne wyniki
                                         ///  zostan przesane w IM_PLUG_UPDATE
        #define IMC_CONNECTED        7 ///< Zwraca true, jeli jestemy podczeni do internetu.
        #define IMC_VERSION          8 ///< Zwraca wersj rdzenia.
								        ///  \param p1 (char *) Wskanik do cigu znakw do zapisania wersji tekstowo, lub NULL.
                                        ///  \return (int) #VERSION_TO_NUM


        #define IMC_SHUTDOWN        10 ///< Zamyka program.
        #define IMC_DISCONNECT      11 ///< Rozcza wszystkie wtyczki z sieci.
        #define IMC_RESTART         17 ///< Restartuje program.
        #define IMC_PROFILESDIR     23 ///< cieka do katalogu z profilami.
                                        ///  \return (const char *)
        #define IMC_PROFILEDIR      12 ///< cieka do katalogu z profilem.
                                        ///  \return (const char *)
        #define IMC_RESTORECURDIR   24 ///< Przywrca aktywn ciek na katalog programu i j zwraca.
									   ///  @return (const char *) katalog z programem		
        #define IMC_KONNEKTDIR      IMC_RESTORECURDIR ///< Przywraca aktywn ciek na katalog programu i j zwraca.
        #define IMC_GETBETALOGIN    25 
        #define IMC_GETBETAPASSMD5  27 
        #define IMC_GETBETAANONYMOUS 31 
		#define IMC_LOGDIR			29 ///< Zwraca ciek do katalogu z log'ami.
										/// @return (char*) cieka zakoczona '\\'
        #define IMC_PROFILECHANGE   13 ///< Zmienia/tworzy profil.
                                        ///  \param p1 (char*) nazwa
                                        ///  \param p2 (bool) true jeli profil ma by utworzony
                                        ///  \return true jeli si udao
        #define IMC_PROFILEREMOVE   14 ///< Usuwa aktualnie uywany profil.
        #define IMC_PROFILEPASS     15 ///< Otwiera okno do ustawiania hasa.
        #define IMC_GETMD5DIGEST    16 ///< Zwraca haso profilu jako MD5Digest.
                                        ///  \param p1 (unsigned char [16]) bufor do zapisania.

        #define IMC_SAVE_CFG        20 ///< Zapisuje ustawienia na dysk.
        #define IMC_SAVE_CNT        21 ///< Zapisuje kontakty na dysk.
        #define IMC_SAVE_MSG        22 ///< Zapisuje kolejk wiadomoci na dysk.
		#define IMC_CFG_CHANGED	28

        #define IMC_SETCONNECT      30 ///< Ustawia wtyczk na licie "rzdanych pocze".
                                        ///  W chwili wykrycia poczenia z internetem, 
                                        ///  lub gdy jest poczenie po kilkudziesiciu sekundach
                                        ///  zostanie wysany do wtyczki komunikat #IM_CONNECT.
                                        /// \param p1 (bool) stan - 1 cz , 0 - przesta prbowa

        #define IMC_THREADSTART     50 // Wiadomo wykorzystywana TYLKO przez UI
        #define IMC_THREADEND	   51   // Wiadomo wykorzystywana TYLKO przez UI

        #define IMC_NEWMESSAGE     100 ///< Dodaje wiadomo do kolejki.
                                        ///  \attention Zawarto struktury moe ulec zmianie! Jeeli tworzymy bufory tekstowe, zwalnia trzeba je przez
                                        ///  lokalne kopie adresw, a nie wskaniki w strukturze!!!
                                        ///  \param p1 (cMessage*) wiadomo.
                                        ///  \return (int) id wiadomosci

        //       #define NMF_SEND      1   // Flagi wiadomosci

        #define IMC_MESSAGEQUEUE   101 ///< Sprawdza kolejk wiadomoci.
                                        ///  Prbuje przyj/rozesa oczekujce wiadomoci.
                                        ///  \param p1 (sMESSAGESELECT*) ktre wiadomoci  maja zosta sprawdzone.
        #define IMC_MESSAGENOTIFY  102 ///< Szuka powiadomienia o nowej wiadomoci dla danego UIDa w kolejce wiadomoci.
                                        ///  \param p1 (sMESSAGENOTIFY*) struktura podajca czego szuka i przyjmujca wynik.
        #define IMC_MESSAGEWAITING 103 ///< Podaje ile wiadomoci oczekuje w kolejce
                                        ///  \param p1 (sMESSAGESELECT*) ktre wiadomoci maj zosta uwzgldnione
                                        ///  \return (int) liczba wiadomoci speniajcych kryteria
        #define IMC_MESSAGEREMOVE  104 ///< Usuwa wiadomoci z kolejki.
                                        ///  \param p1 (sMESSAGESELECT*) Rodzaj wiadomoci do usunicia
                                        ///  \param p2 (int) Ile maxymalnie usun
                                        ///  \return false gdy si nie powiedzie
        #define IMC_MESSAGEGET     106 ///< Pobiera pierwsz wiadomo ktra spenia kryteria.
                                        ///  \param p1 (sMESSAGESELECT*) Rodzaj wiadomoci do pobrania.
                                        ///  \param p2 (cMessage*) Struktura do ktrej zostanie zapisana wiadomo.
                                        ///  \retrun 1 - jeli si powiodo
        #define IMC_MESSAGEACK     107 ///< Potwierdzenie wysania wiadomoci.
                                        ///  W cMessageAck::id \b musimy poda ID potwierdzanej wiadomoci.
                                        ///  Ustawienie msg i ext jest opcjonalne.
                                        ///  \param p1 (cMessageAck*) Struktura z potwierdzeniem.
        #define IMC_MESSAGEPROCESSED 108 ///< Zakoczenie przetwarzania.
                                          /// Po skoczeniu przetwarzania wiadomoci, na ktr odpowiedzielimy flag IM_MSG_processing
                                          /// wysyamy ten komunikat, by rdze "odznaczy" nasz wiadomo. 
                                          /// #IMC_MESSAGEPROCESSED wysya si tylko, gdy wiadomo nie zostaa od razu usunita.
                                          /// \param p1 (int) ID wiadomoci.
                                          /// \param p2 (bool) true - wiadomo moe zosta usunita

        /** Struktura suca do wybierania wiadomoci.
            \sa #IMC_MESSAGEREMOVE #IMC_MESSAGEWAITING #IMC_MESSAGEGET #IMC_MESSAGEQUEUE*/
        typedef  struct sMESSAGESELECT {
            unsigned short s_size;
            int net; ///< Sie kontaktu. Ustaw na #NET_BC aby uy wszystkich sieci.
            const char * uid;  ///< UID kontaktu. Ustaw 0 aby uy wszystkich.
            unsigned int type; ///< Typ wiadomoci. Ustaw na -1 eby uy wszystkich.
            unsigned int wflag; ///< Tylko wiadomoci posiadajce te flagi. 0 eby uy wszystkich.
            unsigned int woflag; ///< Tylko wiadomoci nie posiadajce tych flag. 0 eby uy wszystkich.
            unsigned int id; ///< ID wiadomoci, -1 eby uy wszystkich.
            sMESSAGESELECT() {s_size=sizeof(sMESSAGESELECT);net=NET_BC;uid=0;type=-1;wflag=0;woflag=0;id=-1;}
            sMESSAGESELECT(int _net , const char * _uid=0 , unsigned int _type = -1 , unsigned int _wflag=0 , unsigned int _woflag=0) {
                s_size=sizeof(sMESSAGESELECT);
                net=_net;
                uid=_uid;
                type=_type;
                wflag=_wflag;
                woflag=_woflag;
                id=-1;
            }

        } sMESSAGEPOP , sMESSAGEWAITING;
        #define sMESSAGEWAITING_V1 22

        #define IMC_FINDCONTACT    200 ///< Podaje ID kontaktu.
                                        ///  \param p1 (int) net
                                        ///  \param p2 (char*) UID
                                        ///  \return (int) ID
        #define IMC_PLUG_COUNT    240 ///< Zwraca liczb wtyczek.
        #define IMC_PLUG_HANDLE    241 ///< Zwraca windowsowy uchwyt do wtyczki.
                                        ///  \param p1 (int) pozycja na licie wtyczek.
                                        ///  \return (int) HINSTANCE
        #define IMC_PLUG_ID        243 ///< Zwraca ID wtyczki.
                                        ///  \param p1 (int) pozycja na licie wtyczek.
                                        ///  \return (int) ID
        #define IMC_PLUG_FILE     242  ///< Zwraca ciek do pliku dll wtyczki.
                                        ///  \param p1 (int) pozycja na licie wtyczek.
                                        ///  \return (char*) cieka
        #define IMC_PLUGID_HANDLE  244 ///< Zwraca windowsowy uchwyt do wtyczki.
                                        ///  \param p1 (int) ID wtyczki.
                                        ///  \return (HINSTANCE) uchwyt
        #define IMC_PLUGID_POS     245 ///< Zwraca pozycj wtyczki.
                                        ///  \param p1 (int) ID wtyczki.
                                        ///  \return (int) pozycja
        #define IMC_FINDPLUG       247 ///< Zwraca ID wtyczki.
                                        ///  \param p1 (int) NET wtyczki.
                                        ///  \param p2 (int) Szukane flagi IMT_.
                                        ///  \return (int) ID
        #define IMC_FINDPLUG_BYSIG    248 ///< Zwraca ID wtyczki.
                                        ///  \param p1 (char*) SIG.
                                        ///  \return (int) ID
        #define IMC_FINDPLUG_BYNAME    249 ///< Zwraca ID wtyczki.
                                        ///  \param p1 (char*) name.
                                        ///  \return (int) ID
        #define IMC_PLUG_VERSION    26 ///< Zwraca wersj wtyczki.
                                        ///  \param p1 (int) Pozycja wtyczki na licie, lub -1 aby sprawdzi wersj rdzenia.
								        ///  \param p2 (char *) Wskanik do cigu znakw do zapisania wersji tekstowo, lub NULL.
                                        ///  \return (int) #VERSION_TO_NUM


        #define IMC_STATUSCHANGE   246 ///< Informuje rdze, e za chwil nastpi zmiana statusu wtyczki.
                                        ///  Rdze rozsya IM_STATUSCHANGE.
                                        ///  \warning Ten komunikat trzeba wysa PRZED zmian statusu, nie trzeba podawa
                                        ///  \a plugID. Jako \a status i \a info trzeba poda dane, ktre zaraz zostan ustawione.
                                        ///  sIMessage_StatusChange


        #define IMC_CNT_IGNORED    310 ///< Sprawdza czy kontakt jest ignorowany.
                                        ///  \param p1 (int) net
                                        ///  \param p2 (char*) UID
                                        ///  \return true jeli jest.
        #define IMC_CNT_FIND       IMC_FINDCONTACT ///< \no
        #define IMC_CNT_IDEXISTS   233 ///< Sprawdza czy kontakt o podanym ID istnieje.
                                        /// \param p1 (int) ID.
        #define IMC_CNT_ADD        230 ///< Dodaje kontakt.
                                        ///  Po ustawieniu parametrw kontaktu, lub od razu po #IMC_CNT_ADD
                                        ///  trzeba wysa #IMC_CNT_CHANGED
                                        ///  \param p1 (int) sie
                                        ///  \param p2 (int) UID
                                        ///  \return (int) ID nowego kontaktu
        #define IMC_CNT_REMOVE     231 ///< Usuwa kontakt
                                        ///  \param p1 (int) ID
                                        ///  \param p2 (bool) true - uytkownik zostanie zapytany o zgod.
        #define IMC_CNT_COUNT      201 ///< Zwraca ilo kontaktw.
                                        ///  \return (int) liczba kontaktw.
        #define IMC_CNT_INGROUP    305 ///< Sprawdza czy podany kontakt znajduje sie w grupie.
                                        /// \param p1 (int) ID kontaktu.
                                        /// \param p2 (char*) - grupa do sprawdzenia (jeli == 0 sprawdzi w grupie aktywnej)
                                        /// \return (bool) true jeli znajduje si...
        #define IMC_CNT_CHANGED     232 ///< Kontakt zosta zmieniony.
                                        /// Komunikat powinien by wysyany \b tylko w sytuacji zmiany #CNT_UID, #CNT_NET, lub zaraz po dodaniu!
                                        /// Do wszystkich wtyczek z typem #IMT_CONTACT zostanie rozesane
                                        /// #IM_CNT_CHANGED, lub #IM_CNT_ADD.
                                        /// Nie ma ju potrzeby wysyania #IMI_REFRESH_CNT
                                        /// \param p1 ID kontaktu.
        #define IMC_CNT_SETSTATUS  234 ///< Zmienia status kontaktu.
                                        ///  sIMessage_StatusChange


        #define IMC_IGN_FIND       IMC_CNT_IGNORED
        #define IMC_IGN_ADD        311 ///< Dodaje kontakt do listy ignorowanych.
                                        ///  \param p1 (int) sie
                                        ///  \param p2 (char*) UID
        #define IMC_IGN_DEL        312 ///< Usuwa kontakt z listy ignorowanych.
                                        ///  \param p1 (int) sie
                                        ///  \param p2 (char*) UID

        #define IMC_GRP_FIND       300 ///< Sprawdza czy grupa istnieje.
                                        ///  \param p1 (char*) nazwa grupy.
                                        ///  \return (bool) true jeli istnieje.
        #define IMC_GRP_ADD        301 ///< Dodaje grup.
                                        ///  \param p1 (char*) nazwa grupy.
        #define IMC_GRP_DEL        302 ///< Usuwa grup.
                                        ///  \param p1 (char*) nazwa grupy.
        #define IMC_GRP_RENAME     303 ///< Zmienia nazw grupy.
                                        ///  \param p1 (char*) stara nazwa grupy.
                                        ///  \param p2 (char*) nowa nazwa grupy.


        #define IMC_CFG_SETCOL 1001    ///< Rejestruje kolumn w tabeli ustawie.
                                        ///  \param p1 (sSETCOL*) parametry kolumny.
                                        ///  \attention Moe by wysyane TYLKO PO otrzymaniu komunikatu
                                        ///  #IM_SETCOLS.
        #define IMC_CNT_SETCOL 1101    ///< Rejestruje kolumn w tabeli kontaktw.
                                        ///  \param p1 (sSETCOL*) parametry kolumny.
                                        ///  \attention Moe by wysyane TYLKO PO otrzymaniu komunikatu
                                        ///  #IM_SETCOLS.
        /** Struktura uywana w #IMC_CFG_SETCOL i #IMC_CNT_SETCOL */
        struct sSETCOL {
            int id /// ID kolumny.
              , type /// Typ kolumny (patrz \ref dt_ct_)
              , def /// Domylna warto.
              ;
            unsigned short s_size;
            const char * name; ///< Nazwa kolumny, konieczna, jeli tworzymy kolumn typu Unique (z id == -1).
            sSETCOL(int _id=-1, int _type=0 , int _def=0 , const char* _name=""):s_size(sizeof(sSETCOL)),id(_id),type(_type),def(_def),name(_name) {} 
        };
        #define IMC_CFG_SAVE     1010  ///< Wszystkie ustawienia zostan zapisane.

        // W32
        #define IMC_GETINSTANCE    2000 ///< Zwraca HINSTANCE aplikacji.

        // internal use only.
        #define IMC_GETMSGCOLDESC  3000

        /** @defgroup imc_mru_ MRU.
            Obsuga listy ostatnio uywanych.
            @{
        */
        #define MRU_SET_LOADFIRST  0x1 ///< Zawarto listy zostanie najpierw zaadowana (dziaaj te flagi dla MRU_GET_ !)
        #define MRU_GET_ONEBUFF    0x10 ///< sMRU::buffer jest wskanikiem do bufora (o rozmiarze sMRU::buffSize), ktry zostanie uyty do wszystkich operacji
        #define MRU_GET_USETEMP    0x20 ///< zostanie uyty tymczasowy bufor wewntrzny rdzenia.
            /** Struktura uywana przez IMC_MRU_* */
            struct sMRU {
                int flags; ///< Flagi
                const char * name; ///< Nazwa zestawu
                int count; ///< Rozmiar zestawu
                int buffSize; ///< Rozmiar buforw dla #IMC_MRU_GET
                const char * current; ///< Przy #IMC_MRU_SET i #IMC_MRU_UPDATE podajemy dodawan warto.
                union {
                    char ** values; ///< Tablica \a count buforw. Przy #IMC_MRU_GET musz mie rozmiar podany w \a buffSize.
                                    /// Jeeli jest mniej buforw ni w count, ostatnia pozycja musi by rwna 0.
                    char * buffer; ///< Wskanik do pojedyczego bufora trzymajcego wszystkie informacje
                };
                const char * removed; /// #IMC_MRU_UPDATE zapisze tu element, ktry zosta odrzucony.
                sMRU():flags(0),count(0),buffSize(0),name(0),current(0),values(0){}
            };
            #define IMC_MRU_SET  400 ///< (sIMessage_MRU*) Ustawia list MRU. 
            #define IMC_MRU_GET  401 ///< (sIMessage_MRU*) Pobiera list MRU. 
            #define IMC_MRU_UPDATE  402 ///< (sIMessage_MRU*) Aktualizuje list MRU. 

            /** Struktura do przesyania #IMC_MRU_GET, #IMC_MRU_SET i #IMC_MRU_UPDATE.*/
            struct sIMessage_MRU:public sIMessage_base {
                sMRU * MRU; ///< \brief \no
                sIMessage_MRU(int id , sMRU * MRU):sIMessage_base(id),MRU(MRU){s_size=sizeof(*this);}
            };
        /** @} */


  /** \} */  // Wiadomoci do rdzenia

        
// -----------------------------------------------------------------------------------------------
  // Wiadomosci do UI.dll
  /**
    \defgroup imi_ do UI
    \brief \no

    \{
  */



        #define IMI_PREPARE   IMI_BASE+0   // Tylko dla Rdzenia 
        #define IMI_DEBUG     IMI_BASE+1   ///< Otwiera okno debugowania interfejsu.
                                            ///  Dostpne tylko w wersjach Debug i Beta.
        //  #define IMI_UIINVALIDATE IMI_BASE+100 // (0,0)  -  odnawia listy akcji
// -----------------------------------------------------------------------------------------------
        /**\defgroup imi_action_ Obsuga akcji.
		  System akcji w interfejsie odpowiada za obsug np. kontrolek
		  w konfiguracji, menusw czy przyciskw na toolbarach.
		  @warning Akcje dla kontaktw korzystaj tylko z jednego obiektu akcji, ktry jest "przeczany" na aktualnie dany kontakt. Nie powinno si wic ustawia parametrw akcji zalenie od kontaktu!

           \{
        */
// -----------------------------------------------------------------------------------------------
            /** @defgroup ac_ Numery kontaktw akcji. 
                @{ */
                #define AC_USER 0      ///< Akcja jest przypisana do uytkownika.
                #define AC_NONE -1L    ///< Akcja nie jest przypisana do adnego kontaktu.
                #define AC_CURRENT -2L ///< Ostatnio przypisany kontakt.
            /** @} */

            #define IMI_ACTION    IMI_BASE+101  /**< Wstawia akcj.
                                                    \param p1 (#sUIActionInfo*) Ustawienia akcji. MUSZ by ustawione \a parent i \a id.
                                                    */
            #define IMI_GROUP     IMI_BASE+102  /**< Wstawia grup.
                                                    Dziaa tak samo jak #IMI_ACTION z #ACTS_GROUP ustawionym w \a status.
                                                    \param p1 (#sUIActionInfo*) Ustawienia akcji. MUSZ by ustawione \a parent i \a id.
                                                    \attention Identyfikatory grup \b musz by niepowtarzalne!
                                                    */
            #define IMI_ACTION_CALL  IMI_BASE+103 /**< Wywouje akcj (w innej wtyczce).
                                                        \param p1 (sUIActionNotify_base*) Powiadomienie o zdarzeniu do wysania.
                                                    */
            #define IMI_ACTION_GET   IMI_BASE+107 /**< Pobiera waciwoci akcji.
                                                        \param p1 (sUIActionInfo *). Musi mie ustawiony \a parent , \a id , oraz \a mask (jeeli \a mask == 0 pobiera wszystko).

                                                        \attention Przy pobieraniu \a txt trzeba ustawi \a txt na bufor \b char * i \a txtSize na rozmiar tego bufora.
                                                                    Jeeli \a txt == 0 zostanie ono ustawione na 2 kilobajtowy bufor wewntrzny.
                                                                    <br><Br>
                                                                    Zawsze ustawia \a pos , \a handle i \a type .
                                                    */
            #define IMI_ACTION_SET   IMI_BASE+108 /**< Ustawia waciwoci akcji.
                                                        \param p1  (sUIActionInfo *). Musi mie ustawiony \a parent , \a id , oraz \a mask (jeeli \a mask == 0 ustawia wszystko).
                                                        \attention Mona zmienia tylko: \a status , \a exStyle , \a p1 , \a p2 , \a param , \a ico i \a txt.
                                                        */
            #define IMI_ACTION_GETVALUE IMI_BASE+106 /**< Pobiera warto kontrolki w konfiguracji.
                                                        \param p1  (sUIActionInfo *). Warto zostanie ustawiona w \a txt.
                                                        \return (char *) (to samo co w \a txt), lub 0 jeli wystpi bd.
                                                    */
            #define IMI_ACTION_SETVALUE IMI_BASE+110 /**< Ustawia warto kontrolki w konfiguracji.
                                                        \param p1  (sUIActionInfo *). Warto musi znajdowa si w \a txt.
                                                        \return (char *) (to samo co w \a txt), lub 0 jeli wystpi bd.
                                                    */
            #define IMI_GROUP_ACTIONSCOUNT IMI_BASE+111 /**< Zwraca ilo akcji nalecych do podanej grupy.
                                                        \param p1 (sUIAction*)
                                                        \return (int)
                                                    */
            #define IMI_ACTION_EXISTS  IMI_BASE+112 /**< Sprawdza czy akcja istnieje.
                                                        \param p1 (sUIAction*)
                                                        \return (bool)
                                                        */
            #define IMI_ACTION_ISGROUP  IMI_BASE+113 /**< Sprawdza czy akcja jest grup.
                                                        \param p1 (int) parent
                                                        \return (bool)
                                                        */
            #define IMI_ACTION_GETID  IMI_BASE+114 /**< Zwraca identyfikator akcji na podanej pozycji w grupie.
                                                        \param p1 (int) parent
                                                        \param p2 (int) pozycja
                                                        \return (int) ID
                                                        */
            #define IMI_ACTION_REMOVE IMI_BASE+115 /**< Usuwa akcj.
                                                        \warning Moe zosta wywoane TYLKO gdy akcja nie jest utworzona!
                                                        \param p1 (sUIAction*) akcja do usunicia
                                                        \return (bool)
                                                        */
            #define IMI_ACTION_GETTYPE IMI_BASE+116/**< Pobiera typ akcji (\ref act_).
                                                        \param p1 (sUIAction*) Akcja
                                                        \return (int)
                                                        */
            #define IMI_GROUP_GETHANDLE IMI_BASE+117/**< Pobiera uchwyt grupy (np. uchwyt gwnego okna)
                                                        \param p1 (sUIAction*) Akcja
                                                        \return (HANDLE)
                                                        */
            #define IMI_ACTION_FINDPARENT  IMI_BASE+118/**< Znajduje rodzica akcji o identykatorze sUIAction::id, zaczynajc
                                                             szukanie w sUIAction::parent. Jeeli p2 jest rwne 1, 
                                                             znaleziony identyfikator zostanie usatwiony w strukturze przekazanej
                                                             w polu p1.
                                                        \param p1 (sUIAction*) Akcja. 
                                                        \param p2 (bool) Czy zapisa wynik w p1?
                                                        \return (int)
                                                        */
			#define IMI_GETPLUGINSGROUP IMI_BASE+119 /**< Pobiera identyfikator grupy, ktr uytkownik
														   wskaza jako grup dla menu wtyczek. 
														   @return (int) ID grupy*/
			#define IMI_GROUP_MAKECFG IMI_BASE+120   /**< Jeeli grupa jest grup konfiguracji i okno konfiguracji jest otwarte upewnia si, czy wszystkie kontrolki grupy s utworzone.
														   @param p1 (sUIAction*) Akcja.
														   @return (bool) udao si, lub nie
														   */
			#define IMI_ACTION_SETCNT IMI_BASE+121   /**< Przypisuje kontrolk do kontaktu (podanego w sUIAction).
														   @param p1 (sUIAction*) Akcja.
														   @param p2 (bool) Czy ustawia rekurencyjnie?
														   */
/** Identyfikacja akcji.
            */
            struct sUIAction {
                unsigned int id;     ///< Identyfikator akcji.
                unsigned int parent; ///< Identyfikator grupy.
                unsigned int cnt;    ///< Identyfikator kontaktu dla ktrego zmieniamy/pobieramy parametry akcji
                                    ///  , #AC_NONE, lub #AC_CURRENT ...
                sUIAction() {parent = id = 0;cnt=AC_CURRENT;}
                /**\brief \no

                Dziki temu konstruktorowi wysanie #IMI_ACTION_CALL wyglda tak:
                \code
                ICMessage(IMI_ACTION_CALL , (int)sUIAction(parent , id) , ACTN_ACTION);
                \endcode
                */
                sUIAction(unsigned int _parent , unsigned int _id,unsigned int _cnt=AC_CURRENT) {
                parent = _parent;
                id = _id;
                cnt = _cnt;
                }
            };
            typedef sUIAction sUIACTION;
// -----------------------------------------------------------------------------------------------
            /** \defgroup uiaim_ Maski dla sUIActionInfo.
            \{
            */
                #define UIAIM_STATUS   1 ///< sUIActionInfo::status i sUIActionInfo::statusMask s ustawione.
                #define UIAIM_EXSTYLE  2 ///< sUIActionInfo::exStyle i sUIActionInfo::exStyleMas s ustawione.
                #define UIAIM_P1       4 ///< sUIActionInfo::p1 jest ustawiony.
                #define UIAIM_P2       8 ///< sUIActionInfo::p2 jest ustawiony.
                #define UIAIM_PARAM 0x10 ///< sUIActionInfo::param jest ustawiony.
                #define UIAIM_ICO   UIAIM_P1
                #define UIAIM_TXT  0x40  ///< sUIActionInfo::txt i sUIActionInfo::txtSize s ustawione.

                #define UIAIM_COL   UIAIM_P1 ///< \blank
                #define UIAIM_POS   0x100  ///< \blank
                #define UIAIM_SIZE  0x200  ///< \blank
                #define UIAIM_HANDLE 0x400  ///< \blank
                #define UIAIM_TYPE  0x800  ///< \blank

                #define UIAIM_ALL   0x35F ///< Wszystkie powysze.
                
            // uiaim_
            /** @} */


            /** Waciwoci akcji.
            \sa #IMI_ACTION_GET #IMI_ACTION_SET
            */
            struct sUIActionInfo {
                unsigned short s_size;
                sUIAction act;  ///< Identyfikatory.
                unsigned int pos;  ///<Pozycja na licie w grupie. Pos == -1 oznacza "na kocu" (podczas \ref IMI_ACTION "wstawiania").
                                /// \todo Powinien potrafi rwnie zmieni pozycj.
                unsigned int type; ///<Typ kontrolki przypisanej do akcji ( \ref actt_ ).
                void * handle;     ///<Uchwyt do kontrolki akcji (np w windowsach uchwyty do HWND lub HMENU)
                void * reserved;
                unsigned int mask;       /**< Maska.
                                    Oznacza ktre pola w strukturze s
                                    ustawione.
                                    \attention Pole \a act musi by \b zawsze ustawione! <br>
                                    \sa \ref uiaim_
                                    */
                unsigned int status;     ///<\ref actm_ "Status".
                unsigned int statusMask; ///<Oznacza ktre pola w \a status powinny by zmienione.
                unsigned int exStyle;    /**<Dodatkowe style . \attention W tej chwili nie s one uywane! */
                unsigned int exStyleMask;///<Oznacza ktre pola w \a exStyle powinny by zmienione.
                char * txt;     ///< Tekst przypisany do akcji.
                unsigned int    txtSize; ///< Rozmiar bufora w txt.
                int param;      ///<Parametr uytkownika.
                int p1;         ///<Dodatkowy parametr uzywany przez typy kontrolek.
                int p2;         ///<Dodatkowy parametr uzywany przez typy kontrolek.
                short w,h; ///< Wysoko / szeroko kontrolki

                /**
                \blank
                */
                sUIActionInfo() {s_size=sizeof(sUIActionInfo);mask = act.parent = act.id = pos = 0;handle = 0;}
                /**
                \blank
                */
                sUIActionInfo(int _parent , int _id , int _pos=-1 , int _status=0 , char * _txt = 0 , int _p1=0 , short _w=0 , short _h=0 , int _p2=0 , int _param = 0) {
                    s_size=sizeof(sUIActionInfo);
                    mask = UIAIM_ALL;
                    act.parent=_parent;
                    act.id=_id;
                    pos=_pos;
                    txt=_txt;
                    status=_status;
                    statusMask=-1;
                    exStyleMask=0;
                    p1=_p1;
                    p2=_p2;
                    param=_param;
                    w=_w;
                    h=_h;
                }

                /**
                \blank
                */
                sUIActionInfo(int _parent , int _id) {
                    s_size=sizeof(sUIActionInfo);
                    act.parent = _parent;
                    act.id = _id;
                    mask = 0;

                }
                /**
                \blank
                */
                sUIActionInfo(sUIAction a) {
                    s_size=sizeof(sUIActionInfo);
                    act = a;
                    mask = 0;
                }
            };

                /**
                Waciwoci akcji do konfiguracji.
                */
            struct sUIActionInfo_cfg: sUIActionInfo {
                short x,y; ///< Przesunicie wzgldem osi x/y
                /**
                \blank
                */
                sUIActionInfo_cfg():sUIActionInfo(){s_size = sizeof(sUIActionInfo_cfg);x=y=0;}
                /**
                \blank
                */
                sUIActionInfo_cfg(int _parent , int _id , int _pos=-1 , int _status=0 , char * _txt = 0 , int _col=0 , short _w=0 , short _h=0 , int _p2=0 , int _param = 0)
                : sUIActionInfo(_parent , _id , _pos , _status , _txt , _col, _p2 , _param){
                    s_size = sizeof(sUIActionInfo_cfg);
                    x=y=w=h=0;
                }
                /**
                \blank
                */
                sUIActionInfo_cfg(int _parent , int _id , int _pos=-1 , int _status=0 , char * _txt = 0 , int _col=0 , short _x=0 , short _y=0 , short _w=0 , short _h=0 , int _p2=0 , int _param = 0)
                : sUIActionInfo(_parent , _id , _pos , _status , _txt , _col, _w , _h , _p2 , _param)
                {
                    s_size = sizeof(sUIActionInfo_cfg);
                    x=_x;
                    y=_y;
                }
            };
            #define sUIActionInfo_V1 sizeof(sUIActionInfo)
            /**Powiadomienie.
            Struktura podstawowa wysyana razem z IM_ACTION.

            \sa actn_
            */
            struct sUIActionNotify_base {
                unsigned short s_size;
                sUIAction act;  ///< Identyfikator akcji.
                unsigned int code;  ///< Numer powiadomienia.
                int reserved;   ///< Pozycja zarezerwowana . Musi by rwna 0.
                sUIActionNotify_base(sUIAction _act , unsigned int _code)
                    :s_size(sizeof(sUIActionNotify_base)) , act(_act) , code(_code) , reserved(0) {}
                sUIActionNotify_base(unsigned int _code=0) 
                    :s_size(sizeof(sUIActionNotify_base)) , act(sUIAction()) , code(_code) , reserved(0) {}
            };

            struct sUIActionNotify_2params:public sUIActionNotify_base {
                unsigned int notify1;    ///< Parametr 1.
                unsigned int notify2;    ///< Parametr 2.

                /**
                \blank
                */
                sUIActionNotify_2params(sUIAction _act , unsigned int _code , int _not1 , int _not2 ) 
                    :sUIActionNotify_base(_act , _code) , notify1(_not1) , notify2(_not2)
                    {  s_size=sizeof(sUIActionNotify_2params);}
                sUIActionNotify_2params()
                    :sUIActionNotify_base() , notify1(0) , notify2(0)
                    {  s_size=sizeof(sUIActionNotify_2params);}
                sUIActionNotify_2params(sUIActionNotify_base &base)
                    :sUIActionNotify_base(base.act , base.code) , notify1(0) , notify2(0)
                    {  s_size=sizeof(sUIActionNotify_2params);
                       this->reserved = base.reserved;
                    }
            };
            typedef sUIActionNotify_2params sUIActionNotify;

            struct sUIActionNotify_buff:public sUIActionNotify_base {
                char * buff;
                unsigned int buffSize;
                sUIActionNotify_buff()
                    :sUIActionNotify_base() , buff(0) , buffSize(0)
                    {s_size=sizeof(*this);}
            };


        // imi_action_
        /** @} */

        #define IMI_ICONRES    IMI_BASE+109  ///< Wstawia ikonk z zasobw wtyczki do listy ikonek UI.
                                                /// \deprecated O wiele lepiej uywa #IMI_ICONREGISTER i funkcji pomocniczych.
                                                /// \param p1 (int) Identyfikator ikonki na licie (patrz #UIIcon). 
                                                /// \param p2 (int) Identyfikator ikonki w zasobach wtyczki.
        #define IMI_ICONREGISTER IMI_BASE+130 /**<Rejestruje ikonk/bitmap w UI.
                                                @warning Przy zastpowaniu bitmap na listach poprzednie kopie NIE s usuwane!
                                                   Najlepiej podmienia ikonki jak najrzadziej si da... Zostanie to zmienione
                                                   w nastpnych wersjach...
                                                
                                                @todo Zastpowanie bitmap na listach.
                                                @param p1 (sUIIconRegister*) Informacja o wstawianej ikonce.
                                                @return (bool)

                                               */
        #define IMI_ICONEXISTS IMI_BASE+131 ///< Sprawdza czy ikonka istnieje.
                                             /// @param p1 (int) ID ikonki
                                             /// @param p2 (IML_enum) lista ktr sprawdzi.
                                             /// @return (bool)
        #define IMI_ICONREGISTERLIST IMI_BASE+132 /**< Dodaje cay zestaw ikon.
                                                @warning Przy zastpowaniu bitmap na listach poprzednie kopie NIE s usuwane!
                                                   Najlepiej podmienia ikonki jak najrzadziej si da... Zostanie to zmienione
                                                   w nastpnych wersjach...
                                                @param p1 (sUIIconRegisterList*) Informacja co zarejestrowa
                                               */
        #define IMI_GETICONINDEX  IMI_BASE+133 ///< Zwraca index ikonki na wybranej licie
                                                ///  \param p1 (int) ID ikonki
                                                ///  \param p2 (IML_enum) lista ktr sprawdzi
                                                ///  @return (int) pozycja
        #define IMI_GETICONLIST   IMI_BASE+134 ///< Zwraca uchwyt typu HIMAGELIST do wybranej listy.
                                                ///  @warning Zwrcona lista jest TYLKO do ODCZYTU! Kada modyfikacja dokonana poza UI moe powanie zakci wywietlanie ikon!
                                                ///  @param p1 (IML_enum) lista ktr zwrci
                                                ///  @return (HIMAGELIST)
		#define IMI_ICONUNREGISTER IMI_BASE+135 /**< Usuwa ikonk z wybranej listy...
													@warning Przy usuwaniu z list IML_16 i IML_32 ikony NIE s usuwane z pamici i pniejsza ich podmiana moe wymaga nawet restartu Konnekta!
													@param p1 (int) ID ikonki
													@param p2 (IML_enum) lista
													@return (bool)
												*/
        #define IMI_WARNING     IMI_BASE+200   ///< Wywietla okno z ostrzeeniem.
                                                /// \param p1 (char*) tre.
                                                /// \param p2 (int) dodatkowe flagi, te same co przy MessageBox w WinApi.
                                                /// \return (int) To samo co zwraca MessageBox z WinApi.
        #define IMI_ERROR       IMI_BASE+201  ///< Wywietla okno z bdem.
                                                /// \param p1 (char*) tre.
                                                /// \param p2 (int) dodatkowe flagi, te same co przy MessageBox w WinApi.
                                                /// \return (int) To samo co zwraca MessageBox z WinApi.
        #define IMI_CONFIRM     IMI_BASE+202  ///< Wywietla okno z zapytaniem.
                                                /// \param p1 (char*) tre.
                                                /// \param p2 (int) dodatkowe flagi, te same co przy MessageBox w WinApi.
                                                /// \return (int) Jeli p2==0 to true/false, lub to samo co zwraca MessageBox z WinApi.
        #define IMI_INFORM      IMI_BASE+204  ///< Wywietla okno z informacj.
                                                /// \param p1 (char*) tre.
                                                /// \param p2 (int) dodatkowe flagi, te same co przy MessageBox w WinApi.
                                                /// \return (int) To samo co zwraca MessageBox z WinApi.

        struct sIMessage_msgBox: public sIMessage_base {
            const char * msg;
            unsigned int flags;
            const char * title;
            HANDLE parent;  
            sIMessage_msgBox(unsigned int id , const char * msg="" , const char * title=0 , int _flags = 0 , HANDLE parent = 0):sIMessage_base(id , 0 , 0) 
                {this->s_size = sizeof(*this);
                 this->parent = parent;
                 this->msg = msg;
                 this->flags = _flags;
                 this->title = title;
                }
        };


        #define IMI_DLGPASS     IMI_BASE+205  ///< Okienko podawania hasa.
                                                /// \param (sDIALOG_access*) Parametry okna.
                                                /// \param (bool) Gdy == 1 automatycznie docza do flag DFLAG_SAVE.
                                                /// \return true/false
        #define IMI_DLGLOGIN    IMI_BASE+206  ///< Okienko podawania loginu i hasa.
                                                /// \param (sDIALOG_access*) Parametry okna.
                                                /// \param (bool) Gdy == 1 automatycznie docza do flag DFLAG_SAVE.
                                                /// \return true/false
        #define IMI_DLGSETPASS  IMI_BASE+207  ///< Okienko ustawiania hasa.
                                                /// \param (sDIALOG_access*) Parametry okna.
                                                /// \param (bool) Gdy == 1 automatycznie docza do flag DFLAG_SAVE.
                                                /// \return true/false
        #define IMI_DLGENTER    IMI_BASE+208   ///< Okno wprowadzania tekstu
                                                ///  \param p1 (sDIALOG_enter*) Parametry okna.
                                                /// \return true/false
        #define IMI_DLGBUTTONS  IMI_BASE+213  ///< Okno wyboru (kada opcja to jeden przycisk).
                                                /// \param p1 (sDIALOG_choose *)
                                                /// \return (int) numer przycisku (1-...) lub 0 gdy aden nie zosta wybrany. 

        #define IMI_LONGSTART   IMI_BASE+209   ///< Tworzy okno oczekiwania na zakoczenie duszej operacji.
                                                ///  \param p1 (sDIALOG_long *) Parametry okna. Struktura musi by zachowana a do wywoania #IMI_LONGEND!
        #define IMI_LONGEND     IMI_BASE+210   ///< Zamyka okno utworzone przez #IMI_LONGSTART.
                                                /// \param p1 (sDIALOG_long *) ta sama struktura uyta przy #IMI_LONGSTART.
        #define IMI_LONGSET     IMI_BASE+211   ///< Zmienia okno utworzone przez #IMI_LONGSTART.
                                                /// \param p1 (sDIALOG_long *) ta sama struktura uyta przy #IMI_LONGSTART.
                                                /// \param p2 (int) warto (\ref dset_) oznaczajca co ma zosta zaktualizowane (warto musi najpierw zosta zmieniona w strukturze sDIALOG_long).

        #define IMI_DLGPROFILE  IMI_BASE+212

        /**
        Klasa podstawowa uywana przez wszystkie wiadomoci obsugujce
        okna dialogowe... 
        */
        struct sDIALOG {
            unsigned short s_size;
            char * title; ///< Tytu okienka.
            char * info;  ///< Dodatkowa informacja ...
	        int flag;     ///< Flaga D*_
	        void * handle; ///< Uchwyt do okna dialogowego. Przed utworzeniem okna, \a handle trzeba ustawi na rodzica okna!
            void * param; ///< Parametr uzytkownika
            sDIALOG() {s_size=sizeof(sDIALOG);
                        info=title="";
                        handle=0;
                        param = 0;
				        flag=0;}
        };
        /** Struktura uywana przez okna obsugi hase i loginw.
            
            \attention Wszystkie zwrcone bufory musz zosta od razu skopiowane! */
        struct sDIALOG_access:sDIALOG {
            char * pass; ///< Haso.
            char * login; ///< Login.
            bool save; ///< Stan checkbox'a "czy zapisywa".
	        sDIALOG_access():sDIALOG() {s_size=sizeof(sDIALOG_access);pass=login="";save = false;}
        };
        /** Struktura uywana przez #IMI_DLGENTER.
            \attention Wszystkie zwrcone bufory musz zosta od razu skopiowane! */
        struct sDIALOG_enter:sDIALOG {
            char * value;  ///< Wprowadzona warto.
            char * id;     ///< Identyfikator pola tekstowego. 
                            ///  Podanie identyfikatora uaktywni histori wpisw.
            int maxLength; ///< Maksymalna dugo wprowadzonego tekstu.
            sDIALOG_enter():sDIALOG() {s_size=sizeof(sDIALOG_enter);value="";id="";maxLength=0;}
        };
        /** Struktura uywana przez #IMI_DLGBUTTONS.
            \attention Wszystkie zwrcone bufory musz zosta od razu skopiowane! */
        struct sDIALOG_choose:sDIALOG {
            char * items; ///<Spis elementw. Elementy rozdzielane s znakiem '\n'
            int  def;     ///<Domylnie zaznaczona opcja (liczone od zera)
            int  width;   ///<Szeroko przyciskw.
            sDIALOG_choose():sDIALOG() {s_size=sizeof(sDIALOG_choose);items="";def=1;width=0;}
        };

        struct sDIALOG_profile:sDIALOG {
            char * profile;
            char * pass;
            bool newOne; 
            sDIALOG_profile():sDIALOG() {s_size=sizeof(sDIALOG_profile);pass=profile="";newOne = false;}
        };
        /** Struktura uywana przez #IMI_LONGSTART , #IMI_LONGSET i #IMI_LONGEND.
            */
        struct sDIALOG_long:sDIALOG {
            int progress; ///< Warto 'postpu'.
            bool cancel;  ///< Czy zostao wcinite [Anuluj]?
            int threadId; ///< Id watku, z ktorego tworzone bylo okno
            bool (__stdcall*cancelProc)(sDIALOG_long *); ///< Procedura wywoywana po naciniciu [Anuluj].
            bool (__stdcall*timeoutProc)(int type , sDIALOG_long *); ///< Procedura wywoywana aby sprawdzi czy nastpi timeout.
                                                                    /// \param type Rodzaj wywoania (Patrz \ref timeoutt_)
                                                                    /// \return 0/1 w zalenoci od typu wywoania.
                /** @defgroup timeoutt_ Typy dla sDIALOG_long::timeoutProc
                    @{*/
                    #define TIMEOUTT_START 0x10  ///< Dobry moment eby co zaalokowa.
                    #define TIMEOUTT_END   0x11  ///< Dobry moment eby co zwolni.
                    #define TIMEOUTT_CHECK 1     ///< Sprawdzamy stan. Gdy zwrcimy 1, timeoutPassed zostanie zwikszony. A gdy 0, zostanie wyzerowany. 
                                                  ///  Gdy timeoutPassed > timeout, nastpi przekroczenie limitu czasu i zostanie wywoany #TIMEOUTT_TIMEOUT.
                    #define TIMEOUTT_TIMEOUT 2   ///< Nastpio przekroczenie czasu, mona napisa co mdrego.
                /** @} */
            void * timeoutParam;  ///< Parametr do wykorzystania przez timeoutProc.
            int timeout;          ///< Czas po jakim zostanie wysane TIMEOUTT_TIMEOUT.
            int timeoutPassed;    ///< Ilo ms jaka uplyna od pierwszego TIMEOUTT_CHECK==0.
            HANDLE timeoutHandle; 
            sDIALOG_long():sDIALOG() {s_size=sizeof(sDIALOG_long);progress=-1; cancel = false; cancelProc = 0;
                            timeoutProc=0;timeout=timeoutPassed=0;timeoutHandle=timeoutParam=0;
                            #ifdef _WINBASE_
                            threadId = GetCurrentThreadId();
                            #else
                            threadId = 0;
                            #endif
                            }
        };
// -----------------------------------------------------------------------------------------------
        /** @defgroup dlong_ Flagi dla sDIALOG_long.
            @{
        */

            #define DLONG_MODAL   0x01  ///< Blokuje okna
            #define DLONG_CANCEL  0x02  ///< Mozliwosc anulowania
            #define DLONG_NODLG   0x04  ///< Nie wyswietla okienka ...
            #define DLONG_SINGLE  0x08  ///< Jedyne wyswietlane okienko
            #define DLONG_ONLY    DLONG_SINGLE
            #define DLONG_BLOCKING  0x10 ///< Akcja wykonywana w glownym watku i moze go blokowac.
                                            ///  Akcja musi do czsto wywoywa SleepEx(1) aby pozwoli
                                            ///  na wywoywanie f-cji uaktualniajcych gwny wtek.
                                            ///  \warning Jeeli akcja moe blokowa na duej koniecznie uyj OSOBNEGO
                                            ///  wtku .
            #define DLONG_ANONE  0x100   ///< Bez animacji
            #define DLONG_ARECV  0x200   ///< Animacja "odbieram"
            #define DLONG_ASEND  0x400   ///< Animacja "wysyam"
            #define DLONG_AINET  0x800   ///< Animacja "komunikacja"

        /** @} */
// -----------------------------------------------------------------------------------------------
        /** @defgroup dset_ Flagi dla IMI_LONGSET.
            @{
        */
            #define DSET_TITLE    0x1    ///< Zosta zmieniony tytu.
            #define DSET_INFO     0x2    ///< Zostao zmienione info.
            #define DSET_PROGRESS 0x4    ///< Zosta zmieniony postp.
            #define DSET_BUTTONS  0x8    ///< Zostay zmienione flagi dotyczce przyciskw.
            #define DSET_ANIM     0x10   ///< Zostaa zmieniona animacja.
        /** @} */
// -----------------------------------------------------------------------------------------------
        /** \defgroup dflag_ Flagi dla sDIALOG.
            \{
        */
            #define DFLAG_SAVE  0x1 ///< W sDIALOG_access zostanie pokazany checkbox 'czy zapisa'.
            #define DFLAG_PASS2 0x4 ///< W #IMI_DLGSETPASS zostanie sprawdzona zgodno obu hase.
            #define DFLAG_CANCEL 0x8 ///< Przycisk [Anuluj] ma by widoczny.
        /** @} */

        #define NOTIFY_AUTO    -2              ///< Do ustawienia w #CNT_NOTIFY. 
                                                ///#IMI_NOTIFY znajdzie \a notify wg. kolejki wiadomoci.
                                                ///Jeeli zostanie podane jako \a p1 do #IMI_NOTIFY, zostan sprawdzone wszystkie powiadomienia i ustawione powiadomienie w tray'u.
        #define IMI_NOTIFY      IMI_BASE+1010 ///< Kontakt moe mie nowe powiadomienie. Sprawdzana jest kolejka wiadomoci.
                                                ///  \param p1 Numer kontaktu.
        #define IMI_NEWNOTIFY   IMI_BASE+1011 /**< Ustawia nowe powiadomienie dla kontaktu lub uytkownika (np nowa wiadomo).
                                                    \param p1 (sNOTIFY *) powiadomienie. */
        #define IMI_CNT_ACTIVITY  IMI_BASE+1013 ///< Kontakt wykazuje aktywno.
                                                ///  \param p1 (int) id kontaktu
        #define IMI_CNT_DEACTIVATE  IMI_BASE+1014 ///< Wyzerowanie aktywnoci kontaktu.
                                                ///  \param p1 (int) id kontaktu
        #define IMI_CNT_DETAILS   IMI_BASE+1015 ///< Otwarcie okna informacji o kontakcie.
                                                ///  \param p1 (int) id kontaktu
        /**
            Struktura przesyana w #IMI_NEWNOTIFY
        */
        struct sNOTIFY {
            unsigned short s_size;
            int cnt;    ///< ID kontaktu ktrego notify dotyczy.
            sUIAction action;  ///< Akcja ktra ma by wywoana.
            int notify; ///< Ikona powiadomienia #UIIcon.
            char * info; ///< Informacja.
            int flag; ///< Flaga (w tej chwili flag nie ma :).
            #define NOTIFY_IMPORTANT 1
            /** Wypenia struktur dla kontaktu na licie.
                \param _action Identyfikator akcji.
                \param _notify Identyfikator ikonki powiadomienia.
                \param _cnt Pozycja kontaktu.
            */
            sNOTIFY(sUIAction _action , int _notify , int _cnt = -1) {s_size=sizeof(sNOTIFY);cnt = _cnt; action = _action; notify = _notify;info = (char*)-1;}
            /** Wypenia struktur dla uytkownika.
                \param _action Identyfikator akcji.
                \param _notify Identyfikator ikonki powiadomienia.
                \param _info Tekst powiadomienia (pokazywany w Tray'u). Moe przyj wartoci:
                    - adres do cigu znakw z tekstem.
                    - 0 - tekst nie zostanie zmieniony.
                    - -1 - tekst zostanie zmieniony na domylny.
            */
            sNOTIFY(sUIAction _action , int _notify , char * _info = 0) {s_size=sizeof(sNOTIFY);cnt = -1; action = _action; notify = _notify;info = _info;}
        };

        #define IMI_REFRESH_CNT IMI_BASE+2000 ///< UI powinien odwiey kontakt.
                                                /// Wysyane po zmianie statusu kontaktu, lub ktrej z informacji tekstowych.
                                                /// \param p1 (int) ID kontaktu
                                                /// \param p2 (bool) jeli true - dane zostan odwieone rwnie w oknie z informacjami o kontakcie!
        #define IMI_REFRESH_LST IMI_BASE+2001 ///< Caa lista kontaktw powinna by odwieona.
                                                /// \param p1 (bool) Czy lista ma zosta od nowa wypeniona (raczej nie uywane)?
                                                /// \attention Ten komunikat powinien by uywany TYLKO po dokonaniu duych zmian na licie kontaktw 
                                                ///  (bez wywoywania #IMI_REFRESH_CNT).
        #define IMI_CONFIG      IMI_BASE+2010 ///< Otwiera konfiguracj.
                                                /// \param p1 (int) ID grupy na ktrej ma zosta otwarte.
        #define IMI_CONFIGOPENED IMI_BASE+2011 ///< Zwraca true jeli konfiguracja jest otwarta.

        #define IMI_LST_SELCOUNT IMI_BASE+2020 ///< Zwraca ile kontaktw jest zaznaczonych na licie.
        #define IMI_LST_GETSELPOS  IMI_BASE+2021   ///< Zwraca ID zaznaczonego kontaktu.
                                                    ///  \param p1 (int) numer zaznaczenia poczynajc od 0 do #IMI_LST_SELCOUNT.
        /*
        #define IMI_MSG_INFO    IMI_BASE+3000  //
           #define IMI_MSG_INFO_undelivered 0
           #define IMI_MSG_INFO_delivered 1
        */
        #define IMI_MSG_OPEN    IMI_BASE+3001  // (cMessage*)    internal usage
        #define IMI_MSG_NOTINLIST IMI_BASE+3002 // (cMessage *)  internal usage
        #define IMI_MSG_WINDOWSTATE IMI_BASE+3003 ///< Zwraca stan okna wiadomoci dla kontaktu.
                                                    ///  \p1 Numer kontaktu.
                                                    ///  \return 0 - okno zamknite.
                                                    ///  \return 1 - okno otwarte , aktywne.
                                                    ///  \return -1 - okno otwarte , nieaktywne.
                                                    ///  \return -2 - okno zminimalizowane.
        #define IMI_HISTORY_ADD IMI_BASE+3004  ///< Dodaje wpis do historii
                                                /// \param p1 (sHISTORYADD*)
        /** Struktura uywana przez #IMI_HISTORY_ADD. */
        struct sHISTORYADD {
            unsigned short s_size;
            struct cMessage * m; ///< Wiadomo do dodania
            const char * dir; ///< podkatalog w "history/"
            unsigned int cnt; ///< Identyfikator kontaktu jeli ma by automatycznie utworzona nazwa
            const char * name; ///< Nazwa pliku (jeli cnt==0)
            int session; ///< Oznaczenie sesji.
                        ///  0 - osobna wiadomo, lub pocztek sesji
                        ///  1 - wiadomo naley do sesji
            sHISTORYADD():s_size(sizeof(sHISTORYADD)) {m=0;dir="";cnt=0;name=0;session=0;}
        };
        #define IMI_CNT_SEARCH_FOUND IMI_BASE+4000  ///< Dodaje kontakt do listy znalezionych w odpowiedzi na wyszukiwanie.
                                                    /// \param p1 (sCNTSEARCH*) Informacje o kontakcie.

  /** @} */  // do UI.dll
  /** @} */  // IMESSAGE
// -----------------------------------------------------------------------------------------------
  /**
    \defgroup imerror_ Kody bedu
    \brief \no

    \{
  */

  #define IMERROR_NORESULT 1   ///< Wtyczka nie obsuya wiadomoci.
  #define IMERROR_UNSUPPORTEDMSG IMERROR_NORESULT /// \no
  #define IMERROR_BADSENDER 2  ///< Wiadomo wstrzymana, pojawi si bd...
  #define IMERROR_BADPLUG 3    ///< Podana wtyczka nie istnieje.
  #define IMERROR_THREADSAFE 4 ///< Wiadomo zostaa wywoana w trybie bezpiecznym (bez oczekiwania na powrt).
  #define IMERROR_SHUTDOWN 5   ///< Wiadomo zostaa anulowana z powodu zamykania programu.
  #define IMERROR_BADPARAM 6   ///< Nieprawidowe parametry.
  #define IMERROR_BADSTRUCT 7   ///< Niepoprawna struktura.

  /** @} */ // imerror_

/** @} */  // Komunikacja pomiedzy wtyczkami

// ------------------------------------------------------------------------------------------------
  /**
    \defgroup imig_ idnetyfikatory Grup i Akcji
    \brief \no
    \{
  */
        // Identyfikatory podstawowych akcji w UI tworzacych grupy
        #define IMIG_MAINWND       1   ///< Gwne okno
        #define IMIG_BAR           2   ///< Belka glowna
        #define IMIG_MSGWND        3   ///< Okno wysyania wiadomoci
        #define IMIG_MSGBAR        4   ///< Belka w wysyaniu wiadomoci
        #define IMIG_MAINTB        8   ///< Gwny toolbar
        #define IMIG_SHORTCUTTB    9   ///< Toolbar ze skrtami
        #define IMIG_MAIN          10  ///< Gwne Menu
        #define IMIG_MAIN_OPTIONS  11  ///< Menu opcji
        #define IMIG_MAIN_CNT   12     ///< Dodaj kontakt
        #define IMIG_MAIN_PROFILE  13  ///< Profile
        #define IMIG_HISTORYWND    14
		#define IMIG_PLUGINS       15  /**< Grupa dla ikonek wtyczek w gwnym oknie... Uytkownik moe wybra
										inn, wic numer aktualnej grupy naley pobra przez #IMI_GETPLUGINSGROUP.
									
										*/
        #define IMIG_STATUS          50  ///< Toolbar ze statusami
        #define IMIG_EVENT           51  ///< Menu z wiadomociami od serwerw.
        #define IMIG_EVENT_PARENT    IMIG_STATUS
        #define IMIG_HIDDEN          60  

        #define IMIG_TRAY          20  ///< Tray
        #define IMIG_CNT           30  ///< Menu kontaktu
        #define IMIG_CFGWND        40  ///< Okno ustawie.
        #define IMIG_CFG           41  ///< Korze drzewka ustawie.
        #define IMIG_CFG_CONNECTION 42 ///< Opcje pocze.
        #define IMIG_CFG_USER      43  ///< Ustawienia uytkownika.
        #define IMIG_CFG_SETTINGS  44  ///< Ustawienia programu.
        #define IMIG_CFG_UI        45  ///< Ustawienia interfejsu.
        #define IMIG_CFG_PLUGS     46  ///< Ustawienia wtyczek.

        #define IMIG_NFOWND        70  ///< Okno informacji o kontakcie
        #define IMIG_NFO           71   ///< Drzewko kontrolek informacji
        #define IMIG_NFO_BAR       72   ///< Belka w oknie informacji o kontakcie
        #define IMIG_NFO_TB        73   ///< Gwny toolbar w oknie informacji o kontakcie
  /** @} */ // imig_

// ------------------------------------------------------------------------------------------------
  /**
    \defgroup st_ Numery statusw
        Status skada si z rodzaju statusu (0-0xFF) i flag (0x001-0xFFFFFF00).

    \{
  */

        // STATUS
        /** 
        */
        typedef unsigned int tStatus;
        #define ST_OFFLINE  0  ///< Niedostpny.
        #define ST_BLOCKING 1 ///< Blokujcy (GG)

#define ST_SEMIONLINE 0x20 ///< Od tej granicy zaczynaj si "mniejsze" online'y
        #define ST_NA     0x21       ///< Bardzo away (not-available).
        #define ST_DND    0x22      ///< Nie przeszkadza.
        #define ST_OCCUPIED 0x22     ///< Zajty (ICQ)

        #define ST_ONLINE 0x40   ///< Dostpny.
        #define ST_AWAY   0x41     ///< Away.
        #define ST_AUTOAWAY   0x44     ///< Automatyczny away.
        #define ST_HIDDEN 0x42   ///< Ukryty.
        #define ST_FREEFORCHAT 0x43  ///< FreeForChat (ICQ)

#define ST_SPECIAL 0x60 ///< Od tej granicy zaczynaj si statusy specjalne...

        #define ST_CONNECTING 0xF1  ///< W trakcie czenia, tylko dla kontaktu uytkownika.

        // flagi
        #define ST_NOTINLIST 0x100 ///< Chwilowo na licie, zostanie usunity po zamkniciu programu.
        #define ST_AWAITINGAUTHOR 0x200 ///< Oczekujemy na autoryzacj (ICQ).
        #define ST_IGNORED 0x400        ///< Ignorowany
        #define ST_HIDEMYSTATUS 0x1000  ///< Ukrywanie statusu przed kontaktem

        // maski
        #define ST_MASK        0xFF  ///< Maska statusu.

  /** @} */ // st_
// ------------------------------------------------------------------------------------------------
  /** @defgroup gr_msg Obsuga wiadomoci tekstowych.
      @brief @no
      @{
      */

        #define EXT_PARAM "\x1A" /**< Znak parametru.
                    W cMessage i cMessageAck moemy podawa list dodatkowych parametrw.
                    Kady parametr skada si z poczonych: #EXT_PARAM nazwy '=' wartoci
                    Dziki zastosowaniu "nietypowego znaku, unikamy potrzeby escape'owania znakw.
                    Nazwa moe by dowolnym cigiem znakw z wyjtkiem znakw #EXT_PARAM, '=' i \0.
                    Warto moe by dowolnym cigiem znakw z wyjtkiem znakw #EXT_PARAM i \0.
                    Nazwa jest case-sensitive.

                    Najlepiej uywa gotowych f-cji zadeklarowanych w plug_func.h:
                    GetExtParam i SetExtParam .
                    */
        #define EXT_PARAM_CHAR char(0x1A)
        /**
        Struktura do przekazywania wiadomoci tekstowych .
        \attention Zawarto struktury jest tylko tymczasow \i kopi wiadomoci z \i kolejki.
        \sa \ref msg
        */
        struct cMessage{
            unsigned short s_size;
            unsigned int id;              /**< Identyfikator wiadomoci.
                                    \attention ustawiany przez "rdze". */
            unsigned int net;             /**< Sie wtyczek do ktrych skierowana jest wiadomo.
                                    \sa net_ */
            unsigned int type;            /**< Typ wiadomoci.
                                    \sa mt_ */
            char * fromUid;      ///< UID odbiorcy.
            char * toUid;        ///< UID nadawcy.
            char * body;         ///< Tre wiadomoci.
            char * ext;          ///< Informacje rozszerzone.
                                  /**  Zapisane jako 
                                        \code 
                                        #EXT_PARAM nazwa=warto #EXT_PARAM nazwa2=warto2
                                        ...
                                        \endcode
                                        patrz: #EXT_PARAM .
                                  */
            unsigned int flag;            ///< Flaga.
                                    ///< \sa mf_
            struct sUIAction action;    ///< Akcja powiadomienia dla wiadomoci.
            unsigned int notify;          ///< Akcja i ikonka powiadomienia dla wiadomoci.
                                ///< \sa \ref action \ref msg
            __int64 time;        ///< czas odebrania wiadomoci w formacie zgodnym z cTime64 (zapisane jako __int64).

            cMessage() {s_size=sizeof(cMessage);id=net=type=flag=notify=0; action = sUIAction(0,0); fromUid=toUid=body=ext="";time=0;}
        };
        /**
        Struktura do przekazywania informacji o stanie przesyanych wiadomoci.
        Mona ni podawa jakie wystpiy problemy, lub co stao si z wiadomoci
        po wysaniu (np. czeka na serwerze, lub dosza do odbiorcy...)
        \attention \a id \b musi by ustawiony na numer potwierdzanej i \b istniejcej wiadomoci.
        W midzyczasie wiadomo ta nie moe by usunita przez inny wtek.

        \sa \ref msg
        */
        struct cMessageAck {
            unsigned short s_size;
            unsigned int id;   /**< Identyfikator wiadomoci ktr potwierdzamy.
                                    */
            char * msg; /**< Tekst potwierdzenia. */
            char * ext; /**< Dodatkowe parametry. */
            unsigned int flag; ///< Flagi \ref mack_.
            cMessageAck() {s_size=sizeof(cMessageAck);}

        };

    /**  
        \defgroup mt_ typy wiadomoci tekstowych
        \brief \no
        \{
    */
            typedef unsigned int tMsgType;
            #define MT_MESSAGE      1    ///< Zwyka wiadomo.
            #define MT_QUICKEVENT   2    ///< Krtka notka (kasowana automatycznie w kolejce) (np. wiadomo nie dosza itp.)
            #define MT_EVENT        (3|MT_MASK_NOTONLIST)    ///< wydarzenie (np. kto mnie doda do swojej listy itp.)
            #define MT_SERVEREVENT  (4|MT_MASK_NOTONLIST)    ///< Wiadomo od serwera.
            #define MT_AUTHORIZE    (5|MT_MASK_NOTONLIST)    ///< Proba o autoryzacje (ICQ).
            #define MT_CONFERENCE   (6|MT_MASK_NOTONLIST)    ///< Wiadomo konferencyjna.
            #define MT_FILE         7 ///< Przesanie pliku.
            #define MT_MAIL         8 ///< Email.
            #define MT_SMS          9 ///< Np. potwierdzenie dotarcia sms'w.
            #define MT_SOUND        10 ///< Rozmowa gosowa.
            #define MT_URL         (11|MT_MASK_NOTONLIST)    ///< URL. 
                                                                /// Jako dodatkowe parametry w ext przyjmuje Width i Heigth
            #define MT_SPECIAL      12 ///< Nieokreslona wiadomosc.
            #define MT_SPECIAL_NOL (13|MT_MASK_NOTONLIST) ///< Nieokreslona wiadomosc spoza listy.

            #define MT_MASK_NOTONLIST 0x1000  ///< Oznacza e ta wiadomosc nie zostanie
                                            ///  wywietlona na liscie, ani nie zostanie
                                            ///  sprawdzone czy docelowy kontakt na licie
                                            ///  si znajduje

    /** @} */ // mt_
    // ------------------------------------------------------------------------------------------------
    /**
        \defgroup mf_ flagi wiadomoci tekstowych
        \brief \no
        @{
    */
            #define MF_SEND         2 ///< Wiadomo przeznaczona do wysania
            #define MF_NOEVENTS     4 ///< #MT_QUICKEVENT maj nie by wysyane
            #define MF_NOSAVE       8 ///< Wiadomo nie zostanie zapisana na dysk ...
            #define MF_REQUESTOPEN  0x10 ///< \brief #IM_MSG_OPEN / #IM_MSG_SEND zostanie wysane z #IMC_MESSSAGEQUEUE tylko
                                        ///  gdy zostanie ono wywoane dla tego typu i sieci wiadomoci.
            #define MF_PROCESSING   0x20 ///< Flaga wewntrzna oznaczajca e wiadomo jest w trakcie przetwarzania, Nie powinna by uywana!
            #define MF_OPENED       0x40   ///< Wiadomo ju zostaa otwarta. Teraz czeka w kolejce na usunicie.
                                            ///  Flaga ta jest czyszczona podczas zamykania. 
            #define MF_HANDLEDBYUI  0x80 ///< Wiadomo zostanie obsuona przez UI
            #define MF_AUTOMATED    0x100   ///< Wiadomo zostaa stworzona przez jaki "automatyczny"
                                            /// proces, wic, gdy jestemy ukryci, nie powinna by
                                            /// wysyana.
            #define MF_HTML    0x200     ///< Tre wiadomoci zawiera znaczniki HTML, a znaki specjalne s kodowane (przynajmniej > = &gt; < = &lt; i " = &quot;
										 ///  Html powinien by sformatowany jak XHTML (<img/>, wszystkie atrybuty w "" itd..)

            #define MF_QE_NORMAL    0x10000 ///< MT_QUICKEVENT narysuje zwyk czcionk...
            #define MF_QE_SHOWTIME  0x20000 ///< MT_QUICKEVENT pokae czas nadejcia...

            
    /** @} */ // mf_
    /**
        \defgroup mex_ Nazwy wartoci w polach cMessage::ext
        \brief \no
        @{
    */
            #define MEX_ADDINFO "AddInfo"
            #define MEX_DISPLAY "Display"
            
    /** @} */ // mf_
    /**
        \defgroup mack_ Flagi potwierdze wiadomoci (#IMC_MESSAGEACK i #IM_MSG_ACK)
        \brief \no
        \{
    */
            #define MACK_FAILED  0x1 ///< Wystpi bd
            #define MACK_PROCESSING 0x2 ///< W trakcie przetwarzania

            #define MACK_NOBROADCAST 0x100 /**< Ack nie zostanie rozesane do wtyczek #IMT_MESSAGEACK.
                                                 Przydatne, jeli chcemy tylko zmieni informacj pokazywan w oknie
                                                 kolejki.
                                                 */

            #define MACK_IMPORTANT 0x10 ///< Komunikat jest istotny, bdzie pokazywany duej
            #define MACK_VERYIMPORTANT 0x20 ///< Komunikat jest bardzo istotny.
    /** @} */ // mack_

/** @} */
/** @addtogroup imc_ 
    @{*/
    /** Struktura wykorzystywana przez #IMC_MESSAGENOTIFY.
        Podajemy w niej net i uid kontaktu i otrzymujemy action i notify suce
        do otwarcia tego typu wiadomoci. Struktura jest przede wszystkim 
        wykorzystywana przez UI do pokazywania odpowiednich ikonek przychodzcych wiadomoci.*/ 
    struct sMESSAGENOTIFY {
        unsigned short s_size;
        int net;       ///< Sie kontaktu.
        char * uid;   ///< UID kontaktu.
        sUIAction action;  ///< Akcja otwierajca wiadomo.
        int notify;       ///< Ikonka wiadomoci.
        unsigned int id; ///< Identyfikator wiadomoci.
        sMESSAGENOTIFY() {s_size=sizeof(sMESSAGENOTIFY);id = 0;}
    };

/**@}*/

//-------------------------------------------------------------------------------------------------
  /**
    \defgroup gr_cfg Kolumny konfiguracji
    Zanim zaczniemy korzysta z tablic konfiguracji trzeba zarejestrowa typy kolumn
    wysyajc #IMC_CNT_SETCOL i #IMC_CFG_SETCOL w odpowiedzi na #IM_SETCOLS.

    Odczyt i zapis odbywa si poprzez makra zdefiniowane w \ref gr_cfg.
    Dodatkowo rdze, UI i wtyczki maj zadeklarowane swoje kolumny.

    Kolumny typu #DT_CT_PCHAR zazwyczaj maj te flag #DT_CF_CXOR.

    \{
  */
//-------------------------------------------------------------------------------------------------

         #define DT_ROWID_MASK 0x40000000  ///< Bit oznaczajcy, e "numer wiersza", jest identyfikatorem wiersza.
                                            /// \sa #ISCNTID #GETCNTID cCtrl::DTgetID()

        /** @defgroup dt_ct_ Typy kolumn 
            Typ kolumny skada si z 8 bitowego typu (jak np. #DT_CT_INT) i flag.
            @{ */
            #define DT_CT_INT 0    ///< 4 bajty (int)
            #define DT_CT_PCHAR 1  ///< Tekst zakoczony znakiem '0'.
            #define DT_CT_STR DT_CT_PCHAR
            #define DT_CT_64     3 ///< 8 bajtw (__int64, double ...)
            #define DT_CT_UNKNOWN -1  ///< dla sDTValue, typ nieznany (zostanie ustawiony).

            #define DT_CF_NOSAVE 0x100  ///< Kolumna nie zostanie zapisana do pliku.
			#define DT_CF_SECRET   0x400       ///< Kolumna moe by hasem i powinna by odpowiednio strzeona...
            #define DT_CF_CXOR      0x01000 ///< Kodowanie kolumn poprzez XORing. Dziaa tylko jako DT_CT_PCHAR|DT_CT_CXOR.

        /** @} */
#ifndef _DTABLE_
        struct sDTValue {
            short type; ///< Typ przekazywanej wartoci
            union {
                struct {
                    union {
                        char * vChar;
                        const char * vCChar;
                    };
                    unsigned int buffSize;
                };
                int vInt;
                __int64 vInt64;
            };
            sDTValue(short type=DT_CT_UNKNOWN):type(type) {vInt64 = 0;buffSize=0;}
        };
#endif // _DTABLE_

        /**
            \defgroup msg_ tabela wiadomoci tekstowych
            W tej chwili nie ma bezporedniego dostpu do tablicy wiadomoci!

            \{
        */
            // Msg
            #define MSG_ID             0 ///< #DT_CT_INT ID.
            #define MSG_NET            1 ///< #DT_CT_INT Sie.
            #define MSG_TYPE           2 ///< #DT_CT_INT Typ.
            #define MSG_FROMUID        3 ///< #DT_CT_PCHAR Od UIDa (odebrana).
            #define MSG_TOUID          4 ///< #DT_CT_PCHAR Do UIDa (wysyana).
            #define MSG_BODY           5 ///< #DT_CT_PCHAR Tre.
            #define MSG_EXT            6 ///< #DT_CT_PCHAR Dodatkowe informacje.
            #define MSG_FLAG           7 ///< #DT_CT_INT Flaga.
            #define MSG_ACTIONP        8 ///< #DT_CT_INT | #DT_CF_NOSAVE  Grupa akcji.
            #define MSG_ACTIONI        12 ///< #DT_CT_INT | #DT_CF_NOSAVE Akcja.
            #define MSG_NOTIFY         9 ///< #DT_CT_INT | #DT_CF_NOSAVE  Ikonka powiadomienia.
            #define MSG_HANDLER        10 ///< #DT_CT_INT | #DT_CF_NOSAVE Wtyczka obsugujca.
            #define MSG_TIME           11 ///< #DT_CT_64 Czas jako cTime64 Czas odebrania/wysania.

            #define C_MSG_COLCOUNT     13

        /**
            @}
            @defgroup cfg_ tabela Konfiguracji
            \brief \no
            Niektre kolumny s w tej chwili nie uywane (byy w poprzednich wersjach)...
            Niedugo najprawdopodobniej zostan wykorzystane.
            @{
        */
            // Cfg - CORE'a
            #define CFG_0              0 ///< nieuywany.
            #define CFG_VERSIONS       1 ///< Wersje ostatnio uywanych pluginw.
            #define CFG_APPFILE        2 ///< #DT_CT_PCHAR | #DT_CF_NOSAVE cieka do pliku konnekt.exe.
            #define CFG_APPDIR         3 ///< #DT_CT_PCHAR | #DT_CF_NOSAVE cieka do katalogu z programem.
            #define CFG_PROXY          4 ///< #DT_CT_INT Czy proxy ma by uywane?
            #define CFG_PROXY_AUTO     15 ///< #DT_CT_INT Pobieranie ustawie z IE
            #define CFG_PROXY_VERSION  5 ///< #DT_CT_PCHAR Rodzaj proxy (w tej chwili tylko "")
            #define CFG_PROXY_AUTH     6 ///< #DT_CT_INT Czy uywa logowania?
            #define CFG_PROXY_LOGIN    7 ///< #DT_CT_PCHAR Login do proxy.
            #define CFG_PROXY_PASS     8 ///< #DT_CT_PCHAR Haso do proxy.
            #define CFG_PROXY_HOST     9 ///< #DT_CT_PCHAR Adres proxy.
            #define CFG_PROXY_PORT     10 ///< #DT_CT_INT  Port proxy.
            #define CFG_PROXY_HTTP_ONLY 21 ///< #DT_CT_INT Proxy tylko dla http.
            #define CFG_AUTO_CONNECT   11 ///< #DT_CT_INT  czenie automatyczne.
            #define CFG_12             12 ///< nieuywany
            #define CFG_13             13 ///< nieuywany
            #define CFG_14             14 ///< nieuywany
            #define CFG_IGNORE         16 ///< #DT_CT_PCHAR Lista ignorowanych.
            #define CFG_GROUPS         17 ///< #DT_CT_PCHAR Lista grup kontaktw.
            #define CFG_CURGROUP       18 ///< #DT_CT_PCHAR Aktualna grupa kontaktw.
            #define CFG_DIALUP         19 ///< #DT_CT_INT Poczenie przez modem
            #define CFG_RETRY          20 ///< #DT_CT_INT Wznawianie pocze
            #define CFG_LOGHISTORY     22 ///< #DT_CT_INT Zapisywanie historii
            #define C_CFG_COLCOUNT     23
        /**
            @}

            @defgroup cnt_ tabela Kontaktw
            \brief \no

            @{
        */
        // Cnt
            #define CNT_UID            0 ///< #DT_CT_PCHAR UID.
            #define CNT_NET            1 ///< #DT_CT_INT Sie.
            #define CNT_STATUS         2 ///< #DT_CT_INT Status.
            #define CNT_STATUSINFO     18 ///< #DT_CT_PCHAR Opis statusu.
            #define CNT_NOTIFY         3 ///< #DT_CT_INT | #DT_CF_NOSAVE Ikonka powiadomienia.
            #define CNT_HOST           4 ///< #DT_CT_PCHAR | #DT_CF_NOSAVE IP.
            #define CNT_PORT           5 ///< #DT_CT_INT | #DT_CF_NOSAVE Port.
            #define CNT_NAME           6 ///< #DT_CT_PCHAR Imi.
            #define CNT_SURNAME        7 ///< #DT_CT_PCHAR Nazwisko.
            #define CNT_NICK           17 ///< #DT_CT_PCHAR Pseudo.
            #define CNT_DISPLAY        8 ///< #DT_CT_PCHAR Nazwa wywietlana.
            #define CNT_CELLPHONE      9 ///< #DT_CT_PCHAR Komrka.
            #define CNT_PHONE          10 ///< #DT_CT_PCHAR Stacjonarny.
            #define CNT_EMAIL          11 ///< #DT_CT_PCHAR Email.
            #define CNT_INFO           12 ///< #DT_CT_PCHAR Info.
            #define CNT_CITY           13 ///< #DT_CT_PCHAR Miasto.
            #define CNT_COUNTRY        14 ///< #DT_CT_PCHAR Kraj
            #define CNT_BORN           19 ///< #DT_CT_INT Urodzony YYYYMMDD (w hexie)
            #define CNT_GENDER         20 ///< #DT_CT_INT Pe \ref gender_
            #define CNT_CLIENT         15 ///< #DT_CT_PCHAR Nazwa i wersja uywanego softu.
            #define CNT_CLIENTVERSION  28 ///< #DT_CT_INT Wersja Softu
            #define CNT_LASTMSG        16 ///< #DT_CT_INT | #DT_CF_NOSAVE ID ostatniej wiadomoci.
            #define CNT_GROUP          21 ///< #DT_CT_PCHAR Grupa do ktrej naley.
            #define CNT_ACT_PARENT     22 ///< #DT_CT_INT | #DT_CF_NOSAVE Parent akcji powiadomienia.
            #define CNT_ACT_ID         23 ///< #DT_CT_INT | #DT_CF_NOSAVE ID akcji powiadomienia.
            #define CNT_INTERNAL       24 // Dla rdzenia.
            #define CNT_STREET         25 ///< #DT_CT_PCHAR - ulica.
            #define CNT_POSTALCODE     26 ///< #DT_CT_PCHAR - kod pocztowy.
            #define CNT_NOTIFY_MSG     27 ///< #DT_CT_INT | #DT_CF_NOSAVE ID wiadomoci powiadomienia.
            #define CNT_LASTACTIVITY   29 ///< #DT_CT_64 Czas ostatniej aktywnoci.

            #define C_CNT_COLCOUNT     30

            #define CNTM_STATUS    ST_MASK
            #define CNTM_FLAG      0xFFFFFF00
        /** @} */ // cnt_
    /** @} */ // gr_cfg
    /** @defgroup gender_ Oznaczenie pci
        @{ */
        #define GENDER_UNKNOWN 0 ///< Nieznana
        #define GENDER_FEMALE  1 ///< Kobieta
        #define GENDER_MALE    2 ///< Mczyzna
    /** @} */

// gr_shared
/** @} */


 #pragma pack(pop)

#endif
